/******************************************************************************
** TOS_SpillBlood By TwentyOneScore@BeerInHand.com
** Please email improvements/suggestions...
**
**** Goals ********************************************************************
** 1) Protect your Town Center. You lose if it is destroyed.
** 2) Kill enemy Human Units to gain favor.
** 3) Control Plenty Vaults to gain resources.
**
**** Areas ********************************************************************
** There are 3 main areas.
** Safe Zone: Gather resources safely without worry in this area.
** Pick Zone: Select Civilization, Buy Units, Sell Favor.
** Battle Zone: Player Base and Plenty Vaults. Action happens here.
**
**** Peons ********************************************************************
** Players start with a Greek Villager, Norse Gatherer, Dwarf, and Ox Cart.
** Task Peons to collect resources in the Safe Zone.
**
**** Units ********************************************************************
** Human units auto-spawn in the battle area based on Favor held by player.
** Pick Civ with the Sword Bearer in Pick Zone to auto-spawn that Civ's Units
** Heroes and Myth Units can be purchased with Haft Bearer in Pick Zone.
**
**** Upgrades *****************************************************************
** Upgrades may be purchased using resources at various buildings.
** All upgrades give 3x normal listed bonuses - except Tower Upgrades.
** Building(Tower/TC), Unit(Armory), and Economic(Ox) upgrades are available.
** Fully upgraded TC has about 50% more hitpoints.
**
** SPECIAL UPGRADE BONUSES:
** Upgrade to Fortified Town Center to get Free Sentinels.
** Upgrade PickAxe, HandAxe, or Plow to get a free Laborer in the Safe Zone.
**
**** Relics *******************************************************************
** Collect Relics in Battle Zone. All Relics will be the same type, so getting
** more than one will affect a particular unit stats much more.
**
**** Buildings ****************************************************************
** Buildings may be constructed at regular cost in the Safe and Battle Zones.
** Players must build a Temple in the Battle Zone to collect relics.
** Your Greek Villager can pray at Temple built in Safe Zone for extra Favor.
** Additional Towers can be constructed to protect your town center.
**
**** Thanks *******************************************************************
** Matei for Norse Wars, and M0nty Pyth0n for Mythland. Both served as a
** tuitorial for me on how the RMS works, particularly how to set up triggers.
**
**** Future Scripters *********************************************************
** You are of course, free to use this work as a guideline and basis of your
** own. However, if you do...Please note that you were inspired by my work
** which was inspired by their work...and find out who inspired them too.
**
*******************************************************************************/

// GLOBALS ***************************************************
int MapSkin = 1;
int SeaOrLand = 1;  // SEA=1 LAND=0
float SeaLevel = -6;
int failCount=0;
int k=0;
int myNumPlayers=0;
float KillLoc=0;
// DEFINE SOME CONSTANTS
string CivPicker="Sword Bearers";
string BuyPicker="Thor Hammer Haft";
string PlayerBase="Citadel Center";
string BuyHeroList="";
string BuyMythList="";
string BuyGPList="";
string GotTransportGP="Underworld Passage";

string HeroUnit1="";
string HeroUnit2="";
string MythUnit_N="";
string MythUnit_E="";
string MythUnit_G="";

// Tech ID constants
//Techs: 392 total
const int cTechAge1=0;
const int cTechAge2=1;
const int cTechAge3=2;
const int cTechMediumArchers=3;
const int cTechHeavyArchers=4;
const int cTechChampionArchers=5;
const int cTechMediumInfantry=6;
const int cTechHeavyInfantry=7;
const int cTechChampionInfantry=8;
const int cTechHusbandry=9;
const int cTechPlow=10;
const int cTechIrrigation=11;
const int cTechCopperWeapons=12;
const int cTechBronzeWeapons=13;
const int cTechIronWeapons=14;
const int cTechCopperMail=15;
const int cTechBronzeMail=16;
const int cTechIronMail=17;
const int cTechCopperShields=18;
const int cTechBronzeShields=19;
const int cTechIronShields=20;
const int cTechAmbassadors=21;
const int cTechTaxCollectors=22;
const int cTechCoinage=23;
const int cTechMediumCavalry=24;
const int cTechHeavyCavalry=25;
const int cTechChampionCavalry=26;
const int cTechWatchTower=27;
const int cTechGuardTower=28;
const int cTechBallistaTower=29;
const int cTechBoilingOil=30;
const int cTechBurningPitch=32;
const int cTechMasons=33;
const int cTechPickaxe=34;
const int cTechHandAxe=35;
const int cTechShaftMine=36;
const int cTechBowSaw=37;
const int cTechQuarry=38;
const int cTechCarpenters=39;
const int cTechBravery=40;
const int cTechValleyoftheKings=41;
const int cTechLightningStorm=42;
const int cTechLocustSwarm=43;
const int cTechTornado=44;
const int cTechWinterHarvest=45;
const int cTechSafeguard=46;
const int cTechRampage=47;
const int cTechMithrilBreastplate=48;
const int cTechCallOfValhalla=49;
const int cTechArcticWinds=50;
const int cTechArcticGale=51;
const int cTechWrathOfTheDeep=52;
const int cTechSpiritedCharge=53;
const int cTechThunderingHooves=54;
const int cTechBerserkergang=55;
const int cTechRime=56;
const int cTechFrost=57;
const int cTechDraftHorses=58;
const int cTechEngineers=59;
const int cTechArchitects=60;
const int cTechMeteor=61;
const int cTechBoneBow=62;
const int cTechAxeofVengeance=63;
const int cTechDesertWind=64;
const int cTechEnclosedDeck=65;
const int cTechCladding=66;
const int cTechFortifiedWall=67;
const int cTechAge1Zeus=68;
const int cTechSkinOfTheRhino=69;
const int cTechAge15Egyptian=70;
const int cTechSacredCats=71;
const int cTechGraniteBlood=72;
const int cTechHamarrtroll=73;
const int cTechCriosphinx=74;
const int cTechHieracosphinx=75;
const int cTechMonstrousRage=76;
const int cTechPhobosSpearofPanic=77;
const int cTechBacchanalia=78;
const int cTechSunRay=79;
const int cTechSylvanLore=80;
const int cTechForgeofOlympus=81;
const int cTechAge1Hades=82;
const int cTechAge1Poseidon=83;
const int cTechCreateGold=84;
const int cTechAge1Ra=85;
const int cTechAge1Isis=86;
const int cTechAge1Set=87;
const int cTechAge1Odin=88;
const int cTechAge1Thor=89;
const int cTechAge1Loki=90;
const int cTechAuroraBorealis=91;
const int cTechAge2Athena=92;
const int cTechAge2Ares=93;
const int cTechAge2Hermes=94;
const int cTechAge3Dionysos=95;
const int cTechAge3Apollo=96;
const int cTechAge3Aphrodite=97;
const int cTechAge4Hera=98;
const int cTechAge4Artemis=99;
const int cTechAge4Hephaestus=100;
const int cTechHuntingDogs=101;
const int cTechHandofTalos=102;
const int cTechSarissa=103;
const int cTechAegisShield=104;
const int cTechWingedMessenger=105;
const int cTechAge2Anubis=106;
const int cTechAge2Bast=107;
const int cTechAge2Ptah=108;
const int cTechAge3Hathor=109;
const int cTechAge3Nephthys=110;
const int cTechAge3Sekhmet=111;
const int cTechAge4Thoth=112;
const int cTechAge4Osiris=113;
const int cTechAge4Horus=114;
const int cTechFeetoftheJackal=115;
const int cTechAge4=116;
const int cTechAge2Forseti=117;
const int cTechAge2Heimdall=118;
const int cTechAge2Freyja=119;
const int cTechAge3Skadi=120;
const int cTechAge3Bragi=121;
const int cTechAge3Njord=122;
const int cTechAge4Hel=123;
const int cTechAge4Baldr=124;
const int cTechAge4Tyr=125;
const int cTechSignalFires=126;
const int cTechStoneWall=127;
const int cTechShoulderofTalos=128;
const int cTechSkeletonPower=129;
const int cTechBookofThoth=130;
const int cTechFaceoftheGorgon=131;
const int cTechCitadelWall=132;
const int cTechUnderworldPassage=133;
const int cTechRestoration=134;
const int cTechCarrierPigeons=140;
const int cTechFloodControl=141;
const int cTechPharaohRespawn=142;
const int cTechStartingUnitsNorse=143;
const int cTechStartingUnitsGreek=144;
const int cTechStartingUnitsEgyptian=145;
const int cTechGreatHunt=146;
const int cTechCeaseFire=147;
const int cTechMonument1=148;
const int cTechMonument2=149;
const int cTechMonument3=150;
const int cTechMonument4=151;
const int cTechUndermine=152;
const int cTechDwarvenMail=153;
const int cTechDwarvenShields=154;
const int cTechDwarvenWeapons=155;
const int cTechRain=156;
const int cTechSerpentSpear=157;
const int cTechFloodoftheNile=158;
const int cTechVaultsofErebus=159;
const int cTechLordofHorses=160;
const int cTechOlympicParentage=161;
const int cTechPigSticker=162;
const int cTechLoneWanderer=163;
const int cTechEyesintheForest=164;
const int cTechScallopedAxe=165;
const int cTechRingGiver=166;
const int cTechLongSerpent=167;
const int cTechSwineArray=168;
const int cTechAge15Norse=169;
const int cTechAge15Greek=170;
const int cTechOdinsRavenRespawn=171;
const int cTechSnowStorm=172;
const int cTechHeavyCamelry=173;
const int cTechChampionCamelry=174;
const int cTechBronze=175;
const int cTechPharaohRespawnOsiris=176;
const int cTechNewKingdom=177;
const int cTechMedjay=178;
const int cTechFuneralRites=179;
const int cTechSpiritofMaat=180;
const int cTechCityoftheDead=181;
const int cTechFortifyTownCenter=182;
const int cTechShaduf=192;
const int cTechMonument0=193;
const int cTechRelicAnkhofRa=194;
const int cTechRelicEyeofHorus=195;
const int cTechRelicSistrumofBast=196;
const int cTechRelicHeadofOrpheus=197;
const int cTechRelicRingoftheNibelung=198;
const int cTechRelicStaffofDionysus=199;
const int cTechRelicFettersofFenrir=200;
const int cTechRelicOdinsSpear=201;
const int cTechRelicKitharaofApollo=202;
const int cTechRelicMithrilHorseshoes=203;
const int cTechRelicBowofArtemis=204;
const int cTechRelicWedjatEye=205;
const int cTechRelicNoseoftheSphinx=206;
const int cTechGoldenApples=207;
const int cTechEldhrimnirKettle=208;
const int cTechRelicArrowsofAlfar=209;
const int cTechRelicToothedArrows=210;
const int cTechRelicWandofGambantein=211;
const int cTechProsperity=212;
const int cTechPegasusRelicRespawn=213;
const int cTechRelicGoldenBridleofPegasus=214;
const int cTechEclipse=215;
const int cTechWillofKronos=216;
const int cTechLabyrinthofMinos=217;
const int cTechFlamesofTyphon=218;
const int cTechDivineBlood=219;
const int cTechShaftsofPlague=220;
const int cTechVision=221;
const int cTechBolt=222;
const int cTechSpy=223;
const int cTechFlamingWeapons=224;
const int cTechFlamingWeaponsActive=225;
const int cTechLossofLOS=226;
const int cTechSerpents=227;
const int cTechAnimalMagnetism=228;
const int cTechHealingSpring=229;
const int cTechCurse=230;
const int cTechSentinel=231;
const int cTechSandstorm=232;
const int cTechCitadel=233;
const int cTechWalkingWoods=234;
const int cTechRagnorok=235;
const int cTechNidhogg=236;
const int cTechPlenty=237;
const int cTechSonofOsiris=238;
const int cTechPharaohRespawnCityoftheDead=239;
const int cTechEarthquake=240;
const int cTechAthenianWall=241;
const int cTechHeroesHadesAge1=242;
const int cTechHeroesPoseidonAge1=243;
const int cTechHeroesZeusAge1=244;
const int cTechDwarvenAuger=245;
const int cTechPurseSeine=246;
const int cTechReinforcedHull=247;
const int cTechHuntressAxe=248;
const int cTechForestFire=249;
const int cTechPestilence=250;
const int cTechRelicTriosBow=251;
const int cTechRelicShardofBlueCrystal=252;
const int cTechRelicArmorofAchilles=253;
const int cTechRelicShipofFingernails=254;
const int cTechCrocodopolis=255;
const int cTechLeatherFrameShield=256;
const int cTechElectrumBullets=257;
const int cTechStonesofRedLinen=258;
const int cTechSpearontheHorizon=259;
const int cTechFeral=260;
const int cTechAnastrophe=261;
const int cTechTrierarch=262;
const int cTechThracianHorses=263;
const int cTechRelicShinglesofSteel=264;
const int cTechRelicEyeofOrnlu=265;
const int cTechRelicTuskoftheIronBoar=266;
const int cTechAssignLOS=267;
const int cTechRoarofOrthus=268;
const int cTechAtefCrown=269;
const int cTechNavalOxybeles=271;
const int cTechEnyosBowofHorror=272;
const int cTechDeimosSwordofDread=273;
const int cTechChampionElephants=274;
const int cTechHallofThanes=275;
const int cTechAdzeofWepwawet=276;
const int cTechSlingsoftheSun=277;
const int cTechRamoftheWestWind=278;
const int cTechSundriedMudBrick=279;
const int cTechFuneralBarge=280;
const int cTechNecropolis=281;
const int cTechHammeroftheGods=290;
const int cTechMeteoricIronMail=291;
const int cTechDragonscaleShields=292;
const int cTechTusksofApedemak=293;
const int cTechRelicPandorasBox=294;
const int cTechRelicHerasThundercloudShawl=295;
const int cTechRelicHarmoniasNecklace=296;
const int cTechRelicDwarfenCalipers=297;
const int cTechOracle=298;
const int cTechSonsofSleipnir=299;
const int cTechSetAge2Critter=300;
const int cTechSetAge3Critter=301;
const int cTechSetAge4Critter=302;
const int cTechPoseidonHippocampusRespawn=303;
const int cTechEgyptianbuildingbonus=304;
const int cTechOmniscience=305;
const int cTechMediumAxemen=306;
const int cTechHeavyAxemen=307;
const int cTechChampionAxemen=308;
const int cTechMediumSpearmen=309;
const int cTechHeavySpearmen=310;
const int cTechChampionSpearmen=311;
const int cTechHeavyChariots=312;
const int cTechChampionChariots=313;
const int cTechHeavyElephants=314;
const int cTechMediumSlingers=319;
const int cTechHeavySlingers=320;
const int cTechChampionSlingers=321;
const int cTechRelicGoldenLions=322;
const int cTechRelicMonkeyHead=323;
const int cTechThurisazRune=328;
const int cTechGoldenLionsRelicRespawn=329;
const int cTechMonkeyHeadRelicRespawn=330;
const int cTechRelicCanopicJarofImsety=331;
const int cTechRelicTowerofSestus=332;
const int cTechRelicTrojanGateHinge=333;
const int cTechSPCMeteor=334;
const int cTechOdinsFirstRavens=335;
const int cTechHeroesEgyptianAge1=336;
const int cTechWeakenAge1Units=337;
const int cTechSaltAmphora=338;
const int cTechMediumMigdolShadow=339;
const int cTechPoseidonFirstHippocampus=340;
const int cTechTempleofHealing=341;
const int cTechGreatestofFifty=342;
const int cTechWeaponoftheTitans=346;
const int cTechCrenellations=350;
const int cTechBlessingofZeus=351;
const int cTechRelicGirdleofHippolyta=352;
const int cTechSharedLOS=353;
const int cTechRelicPygmalionsStatue=354;
const int cTechRelicBlackLotus=355;
const int cTechCeasefireEffect=359;
const int cTechNorsebuildingbonus=360;
const int cTechLightningMode=361;
const int cTechFortifiedTents=362;
const int cTechDwarvenShieldsEffect=363;
const int cTechRelicHartersFolly=364;
const int cTechRelicScarabPendant=365;
const int cTechWellofUrd=366;
const int cTechRelicBootsofKickEverything=367;
const int cTechRelicAnvilofHephaestus=368;
const int cTechRelicPeltofArgus=369;
const int cTechRelicOsebergWagon=370;
const int cTechRelicBuhenFlagstone=371;
const int cTechRelicCatoblepasScales=372;
const int cTechRelicTailofCerberus=373;
const int cTechRelicBlanketofEmpressZoe=374;
const int cTechRelicKhopeshofHorus=375;
const int cTechCeaseFireNomad=376;
const int cTechEclipseActive=377;
const int cTechPlentyKOTHenable=378;
const int cTechStartingUnitsThor=379;
const int cTechSetAge1Critter=380;
const int cTechStartingResourcesEgyptian=381;
const int cTechStartingResourcesGreek=382;
const int cTechStartingResourcesNorse=383;
const int cTechRelicReedofNekhebet=384;
const int cTechWeakenTrojanGate=385;
const int cTechBuildTCfaster=386;
const int cTechIncreaseRegeneration=387;

const int cTechEliteHersir=390;

// Tech status constants
const int cTechStatusUnobtainable=0;
const int cTechStatusObtainable=1;
const int cTechStatusAvailable=2;
const int cTechStatusResearching=3;
const int cTechStatusActive=4;
const int cTechStatusPersistent=5;

// My Constants
const int cGoldAmtDwarven=1000;
const int cGoldAmtTiny=1500;
const int cGoldAmtSmall=3000;
const int cGoldAmtLarge=6000;

const int cVeryShort=3;
const int cShort=10;
const int cMedium=20;
const int cLong=40;
const int cVeryLong=80;

const int cSpawnable=1;
const int cNotSpawnable=0;

// MATEI THANKS GO HERE - particularly for his array idea, whew! that saved time
int POP_LIMIT = 160;
int POP_BONUS = 5;

// BuyPickers array
string BuyPicker1=""; string BuyPicker2=""; string BuyPicker3=""; string BuyPicker4="";
string BuyPicker5=""; string BuyPicker6=""; string BuyPicker7=""; string BuyPicker8="";
string BuyPicker9=""; string BuyPicker10=""; string BuyPicker11=""; string BuyPicker12="";
string getBuyPicker(int p=1) {
   if(p==1) {return(BuyPicker1);} else if(p==2) {return(BuyPicker2);} else if(p==3) {return(BuyPicker3);}
   else if(p==4) {return(BuyPicker4);} else if(p==5) {return(BuyPicker5);} else if(p==6) {return(BuyPicker6);}
   else if(p==7) {return(BuyPicker7);} else if(p==8) {return(BuyPicker8);} else if(p==9) {return(BuyPicker9);}
   else if(p==10) {return(BuyPicker10);} else if(p==11) {return(BuyPicker11);} else if(p==12) {return(BuyPicker12);}
}
void setBuyPicker(int p=1, string v="") {
   if(p==1) {BuyPicker1 = v;} else if(p==2) {BuyPicker2 = v;} else if(p==3) {BuyPicker3 = v;}
   else if(p==4) {BuyPicker4 = v;} else if(p==5) {BuyPicker5 = v;} else if(p==6) {BuyPicker6 = v;}
   else if(p==7) {BuyPicker7 = v;} else if(p==8) {BuyPicker8 = v;} else if(p==9) {BuyPicker9 = v;}
   else if(p==10) {BuyPicker10 = v;} else if(p==11) {BuyPicker11 = v;} else if(p==12) {BuyPicker12 = v;}
}

// Player Slots array
int slot1=0; int slot2=0; int slot3=0; int slot4=0;
int slot5=0; int slot6=0; int slot7=0; int slot8=0;
int slot9=0; int slot10=0; int slot11=0; int slot12=0;
int getSlot(int p=1) {
   if(p==1) {return(slot1);} else if(p==2) {return(slot2);} else if(p==3) {return(slot3);}
   else if(p==4) {return(slot4);} else if(p==5) {return(slot5);} else if(p==6) {return(slot6);}
   else if(p==7) {return(slot7);} else if(p==8) {return(slot8);} else if(p==9) {return(slot9);}
   else if(p==10) {return(slot10);} else if(p==11) {return(slot11);} else if(p==12) {return(slot12);}
}
void setSlot(int p=1, int v=0) {
   if(p==1) {slot1 = v;} else if(p==2) {slot2 = v;} else if(p==3) {slot3 = v;}
   else if(p==4) {slot4 = v;} else if(p==5) {slot5 = v;} else if(p==6) {slot6 = v;}
   else if(p==7) {slot7 = v;} else if(p==8) {slot8 = v;} else if(p==9) {slot9 = v;}
   else if(p==10) {slot10 = v;} else if(p==11) {slot11 = v;} else if(p==12) {slot12 = v;}
}

// Armies array
int army1=0; int army2=0; int army3=0; int army4=0;
int army5=0; int army6=0; int army7=0; int army8=0;
int army9=0; int army10=0; int army11=0; int army12=0;
int getArmy(int p=1) {
   if(p==1) {return(army1);} else if(p==2) {return(army2);} else if(p==3) {return(army3);}
   else if(p==4) {return(army4);} else if(p==5) {return(army5);} else if(p==6) {return(army6);}
   else if(p==7) {return(army7);} else if(p==8) {return(army8);} else if(p==9) {return(army9);}
   else if(p==10) {return(army10);} else if(p==11) {return(army11);} else if(p==12) {return(army12);}
}
void setArmy(int p=1, int v=0) {
   if(p==1) {army1 = v;} else if(p==2) {army2 = v;} else if(p==3) {army3 = v;}
   else if(p==4) {army4 = v;} else if(p==5) {army5 = v;} else if(p==6) {army6 = v;}
   else if(p==7) {army7 = v;} else if(p==8) {army8 = v;} else if(p==9) {army9 = v;}
   else if(p==10) {army10 = v;} else if(p==11) {army11 = v;} else if(p==12) {army12 = v;}
}

// HotSpot_Es array
string HotSpot_E1=""; string HotSpot_E2=""; string HotSpot_E3=""; string HotSpot_E4="";
string HotSpot_E5=""; string HotSpot_E6=""; string HotSpot_E7=""; string HotSpot_E8="";
string HotSpot_E9=""; string HotSpot_E10=""; string HotSpot_E11=""; string HotSpot_E12="";
string getHotSpot_E(int p=1) {
   if(p==1) {return(HotSpot_E1);} else if(p==2) {return(HotSpot_E2);} else if(p==3) {return(HotSpot_E3);}
   else if(p==4) {return(HotSpot_E4);} else if(p==5) {return(HotSpot_E5);} else if(p==6) {return(HotSpot_E6);}
   else if(p==7) {return(HotSpot_E7);} else if(p==8) {return(HotSpot_E8);} else if(p==9) {return(HotSpot_E9);}
   else if(p==10) {return(HotSpot_E10);} else if(p==11) {return(HotSpot_E11);} else if(p==12) {return(HotSpot_E12);}
}
void setHotSpot_E(int p=1, string v="") {
   if(p==1) {HotSpot_E1 = v;} else if(p==2) {HotSpot_E2 = v;} else if(p==3) {HotSpot_E3 = v;}
   else if(p==4) {HotSpot_E4 = v;} else if(p==5) {HotSpot_E5 = v;} else if(p==6) {HotSpot_E6 = v;}
   else if(p==7) {HotSpot_E7 = v;} else if(p==8) {HotSpot_E8 = v;} else if(p==9) {HotSpot_E9 = v;}
   else if(p==10) {HotSpot_E10 = v;} else if(p==11) {HotSpot_E11 = v;} else if(p==12) {HotSpot_E12 = v;}
}

// HotSpot_Gs array
string HotSpot_G1=""; string HotSpot_G2=""; string HotSpot_G3=""; string HotSpot_G4="";
string HotSpot_G5=""; string HotSpot_G6=""; string HotSpot_G7=""; string HotSpot_G8="";
string HotSpot_G9=""; string HotSpot_G10=""; string HotSpot_G11=""; string HotSpot_G12="";
string getHotSpot_G(int p=1) {
   if(p==1) {return(HotSpot_G1);} else if(p==2) {return(HotSpot_G2);} else if(p==3) {return(HotSpot_G3);}
   else if(p==4) {return(HotSpot_G4);} else if(p==5) {return(HotSpot_G5);} else if(p==6) {return(HotSpot_G6);}
   else if(p==7) {return(HotSpot_G7);} else if(p==8) {return(HotSpot_G8);} else if(p==9) {return(HotSpot_G9);}
   else if(p==10) {return(HotSpot_G10);} else if(p==11) {return(HotSpot_G11);} else if(p==12) {return(HotSpot_G12);}
}
void setHotSpot_G(int p=1, string v="") {
   if(p==1) {HotSpot_G1 = v;} else if(p==2) {HotSpot_G2 = v;} else if(p==3) {HotSpot_G3 = v;}
   else if(p==4) {HotSpot_G4 = v;} else if(p==5) {HotSpot_G5 = v;} else if(p==6) {HotSpot_G6 = v;}
   else if(p==7) {HotSpot_G7 = v;} else if(p==8) {HotSpot_G8 = v;} else if(p==9) {HotSpot_G9 = v;}
   else if(p==10) {HotSpot_G10 = v;} else if(p==11) {HotSpot_G11 = v;} else if(p==12) {HotSpot_G12 = v;}
}

// HotSpot_Ns array
string HotSpot_N1=""; string HotSpot_N2=""; string HotSpot_N3=""; string HotSpot_N4="";
string HotSpot_N5=""; string HotSpot_N6=""; string HotSpot_N7=""; string HotSpot_N8="";
string HotSpot_N9=""; string HotSpot_N10=""; string HotSpot_N11=""; string HotSpot_N12="";
string getHotSpot_N(int p=1) {
   if(p==1) {return(HotSpot_N1);} else if(p==2) {return(HotSpot_N2);} else if(p==3) {return(HotSpot_N3);}
   else if(p==4) {return(HotSpot_N4);} else if(p==5) {return(HotSpot_N5);} else if(p==6) {return(HotSpot_N6);}
   else if(p==7) {return(HotSpot_N7);} else if(p==8) {return(HotSpot_N8);} else if(p==9) {return(HotSpot_N9);}
   else if(p==10) {return(HotSpot_N10);} else if(p==11) {return(HotSpot_N11);} else if(p==12) {return(HotSpot_N12);}
}
void setHotSpot_N(int p=1, string v="") {
   if(p==1) {HotSpot_N1 = v;} else if(p==2) {HotSpot_N2 = v;} else if(p==3) {HotSpot_N3 = v;}
   else if(p==4) {HotSpot_N4 = v;} else if(p==5) {HotSpot_N5 = v;} else if(p==6) {HotSpot_N6 = v;}
   else if(p==7) {HotSpot_N7 = v;} else if(p==8) {HotSpot_N8 = v;} else if(p==9) {HotSpot_N9 = v;}
   else if(p==10) {HotSpot_N10 = v;} else if(p==11) {HotSpot_N11 = v;} else if(p==12) {HotSpot_N12 = v;}
}

// MythUnit_Ns array
string MythUnit_N1=""; string MythUnit_N2=""; string MythUnit_N3=""; string MythUnit_N4="";
string MythUnit_N5=""; string MythUnit_N6=""; string MythUnit_N7=""; string MythUnit_N8="";
string MythUnit_N9=""; string MythUnit_N10=""; string MythUnit_N11=""; string MythUnit_N12="";
string getMythUnit_N(int p=1) {
   if(p==1) {return(MythUnit_N1);} else if(p==2) {return(MythUnit_N2);} else if(p==3) {return(MythUnit_N3);}
   else if(p==4) {return(MythUnit_N4);} else if(p==5) {return(MythUnit_N5);} else if(p==6) {return(MythUnit_N6);}
   else if(p==7) {return(MythUnit_N7);} else if(p==8) {return(MythUnit_N8);} else if(p==9) {return(MythUnit_N9);}
   else if(p==10) {return(MythUnit_N10);} else if(p==11) {return(MythUnit_N11);} else if(p==12) {return(MythUnit_N12);}
}
void setMythUnit_N(int p=1, string v="") {
   if(p==1) {MythUnit_N1 = v;} else if(p==2) {MythUnit_N2 = v;} else if(p==3) {MythUnit_N3 = v;}
   else if(p==4) {MythUnit_N4 = v;} else if(p==5) {MythUnit_N5 = v;} else if(p==6) {MythUnit_N6 = v;}
   else if(p==7) {MythUnit_N7 = v;} else if(p==8) {MythUnit_N8 = v;} else if(p==9) {MythUnit_N9 = v;}
   else if(p==10) {MythUnit_N10 = v;} else if(p==11) {MythUnit_N11 = v;} else if(p==12) {MythUnit_N12 = v;}
}

// MythUnit_Es array
string MythUnit_E1=""; string MythUnit_E2=""; string MythUnit_E3=""; string MythUnit_E4="";
string MythUnit_E5=""; string MythUnit_E6=""; string MythUnit_E7=""; string MythUnit_E8="";
string MythUnit_E9=""; string MythUnit_E10=""; string MythUnit_E11=""; string MythUnit_E12="";
string getMythUnit_E(int p=1) {
   if(p==1) {return(MythUnit_E1);} else if(p==2) {return(MythUnit_E2);} else if(p==3) {return(MythUnit_E3);}
   else if(p==4) {return(MythUnit_E4);} else if(p==5) {return(MythUnit_E5);} else if(p==6) {return(MythUnit_E6);}
   else if(p==7) {return(MythUnit_E7);} else if(p==8) {return(MythUnit_E8);} else if(p==9) {return(MythUnit_E9);}
   else if(p==10) {return(MythUnit_E10);} else if(p==11) {return(MythUnit_E11);} else if(p==12) {return(MythUnit_E12);}
}
void setMythUnit_E(int p=1, string v="") {
   if(p==1) {MythUnit_E1 = v;} else if(p==2) {MythUnit_E2 = v;} else if(p==3) {MythUnit_E3 = v;}
   else if(p==4) {MythUnit_E4 = v;} else if(p==5) {MythUnit_E5 = v;} else if(p==6) {MythUnit_E6 = v;}
   else if(p==7) {MythUnit_E7 = v;} else if(p==8) {MythUnit_E8 = v;} else if(p==9) {MythUnit_E9 = v;}
   else if(p==10) {MythUnit_E10 = v;} else if(p==11) {MythUnit_E11 = v;} else if(p==12) {MythUnit_E12 = v;}
}

// MythUnit_Gs array
string MythUnit_G1=""; string MythUnit_G2=""; string MythUnit_G3=""; string MythUnit_G4="";
string MythUnit_G5=""; string MythUnit_G6=""; string MythUnit_G7=""; string MythUnit_G8="";
string MythUnit_G9=""; string MythUnit_G10=""; string MythUnit_G11=""; string MythUnit_G12="";
string getMythUnit_G(int p=1) {
   if(p==1) {return(MythUnit_G1);} else if(p==2) {return(MythUnit_G2);} else if(p==3) {return(MythUnit_G3);}
   else if(p==4) {return(MythUnit_G4);} else if(p==5) {return(MythUnit_G5);} else if(p==6) {return(MythUnit_G6);}
   else if(p==7) {return(MythUnit_G7);} else if(p==8) {return(MythUnit_G8);} else if(p==9) {return(MythUnit_G9);}
   else if(p==10) {return(MythUnit_G10);} else if(p==11) {return(MythUnit_G11);} else if(p==12) {return(MythUnit_G12);}
}
void setMythUnit_G(int p=1, string v="") {
   if(p==1) {MythUnit_G1 = v;} else if(p==2) {MythUnit_G2 = v;} else if(p==3) {MythUnit_G3 = v;}
   else if(p==4) {MythUnit_G4 = v;} else if(p==5) {MythUnit_G5 = v;} else if(p==6) {MythUnit_G6 = v;}
   else if(p==7) {MythUnit_G7 = v;} else if(p==8) {MythUnit_G8 = v;} else if(p==9) {MythUnit_G9 = v;}
   else if(p==10) {MythUnit_G10 = v;} else if(p==11) {MythUnit_G11 = v;} else if(p==12) {MythUnit_G12 = v;}
}

// HeroUnit1 array
string HeroUnit1_1=""; string HeroUnit1_2=""; string HeroUnit1_3=""; string HeroUnit1_4="";
string HeroUnit1_5=""; string HeroUnit1_6=""; string HeroUnit1_7=""; string HeroUnit1_8="";
string HeroUnit1_9=""; string HeroUnit1_10=""; string HeroUnit1_11=""; string HeroUnit1_12="";
string getHeroUnit1(int p=1) {
   if(p==1) {return(HeroUnit1_1);} else if(p==2) {return(HeroUnit1_2);} else if(p==3) {return(HeroUnit1_3);}
   else if(p==4) {return(HeroUnit1_4);} else if(p==5) {return(HeroUnit1_5);} else if(p==6) {return(HeroUnit1_6);}
   else if(p==7) {return(HeroUnit1_7);} else if(p==8) {return(HeroUnit1_8);} else if(p==9) {return(HeroUnit1_9);}
   else if(p==10) {return(HeroUnit1_10);} else if(p==11) {return(HeroUnit1_11);} else if(p==12) {return(HeroUnit1_12);}
}
void setHeroUnit1(int p=1, string v="") {
   if(p==1) {HeroUnit1_1 = v;} else if(p==2) {HeroUnit1_2 = v;} else if(p==3) {HeroUnit1_3 = v;}
   else if(p==4) {HeroUnit1_4 = v;} else if(p==5) {HeroUnit1_5 = v;} else if(p==6) {HeroUnit1_6 = v;}
   else if(p==7) {HeroUnit1_7 = v;} else if(p==8) {HeroUnit1_8 = v;} else if(p==9) {HeroUnit1_9 = v;}
   else if(p==10) {HeroUnit1_10 = v;} else if(p==11) {HeroUnit1_11 = v;} else if(p==12) {HeroUnit1_12 = v;}
}

// HeroUnit2 array
string HeroUnit2_1=""; string HeroUnit2_2=""; string HeroUnit2_3=""; string HeroUnit2_4="";
string HeroUnit2_5=""; string HeroUnit2_6=""; string HeroUnit2_7=""; string HeroUnit2_8="";
string HeroUnit2_9=""; string HeroUnit2_10=""; string HeroUnit2_11=""; string HeroUnit2_12="";
string getHeroUnit2(int p=1) {
   if(p==1) {return(HeroUnit2_1);} else if(p==2) {return(HeroUnit2_2);} else if(p==3) {return(HeroUnit2_3);}
   else if(p==4) {return(HeroUnit2_4);} else if(p==5) {return(HeroUnit2_5);} else if(p==6) {return(HeroUnit2_6);}
   else if(p==7) {return(HeroUnit2_7);} else if(p==8) {return(HeroUnit2_8);} else if(p==9) {return(HeroUnit2_9);}
   else if(p==10) {return(HeroUnit2_10);} else if(p==11) {return(HeroUnit2_11);} else if(p==12) {return(HeroUnit2_12);}
}
void setHeroUnit2(int p=1, string v="") {
   if(p==1) {HeroUnit2_1 = v;} else if(p==2) {HeroUnit2_2 = v;} else if(p==3) {HeroUnit2_3 = v;}
   else if(p==4) {HeroUnit2_4 = v;} else if(p==5) {HeroUnit2_5 = v;} else if(p==6) {HeroUnit2_6 = v;}
   else if(p==7) {HeroUnit2_7 = v;} else if(p==8) {HeroUnit2_8 = v;} else if(p==9) {HeroUnit2_9 = v;}
   else if(p==10) {HeroUnit2_10 = v;} else if(p==11) {HeroUnit2_11 = v;} else if(p==12) {HeroUnit2_12 = v;}
}

string pointLoc(float fracX = 0, float fracZ = 0) {
   return(""+rmXFractionToMeters(fracX)+",0,"+
   rmZFractionToMeters(fracZ));
}
// THANKS AGAIN MATEI

float iifF(bool cond=true, float val1=0, float val2=0) {
   if (cond==true) return(val1);
   else return(val2);
}

string chooseRandString(string s1="", string s2="", string s3="", string s4="", string s5="", string s6="") {
   int count = iifF(s1!="",1,0)+iifF(s2!="",1,0)+iifF(s3!="",1,0)+iifF(s4!="",1,0)+iifF(s5!="",1,0)+iifF(s6!="",1,0);
   int r = rmRandInt(1,count);
   if(r==1) {return(s1);} else if(r==2) {return(s2);} else if(r==3) {return(s3);} else if(r==4) {return(s4);} else if(r==5) {return(s5);} else {return(s6);}
}

// DECLARE OUR CONSTRAINTS GLOBAL SO WE CAN USE IN FUNCTIONS

// Building constraints - Used For Additoinal Settlements
int avoidBuildingsShort=cShort;
int avoidBuildingsMedium=cMedium;
int avoidBuildingsLong=cLong;
int avoidBuildingsVeryLong=cVeryLong;

// Gold
int avoidGoldShort=cShort;
int avoidGoldMedium=cMedium;
int avoidGoldLong=cLong;

// Relics
int avoidRelicShort=cShort;
int avoidRelicMedium=cMedium;
int avoidRelicLong=cLong;

void SendChat(string message="", int player=0) {
   rmAddTriggerEffect("Send Spoofed Chat");
    rmSetTriggerEffectParam("Message", message, false);
    rmSetTriggerEffectParamInt("PlayerID", player, false);
}

void TimedMsg(string message="", int length=15) { // DOES THIS CAUSE OOS ERROR ON EOS?
   SendChat(message);
//   rmAddTriggerEffect("Counter:Add Timer");
//   rmSetTriggerEffectParamInt("Start",length);
//   rmSetTriggerEffectParamInt("Stop",1);
//   rmSetTriggerEffectParam("Msg", message);
}

/* MATH FUNCTIONS  ************************************/
float sin(float Angle=0) {
   float MyAngle=(Angle+360) % 360;
   if (MyAngle<= 0 ) return (0.00000000000000);
   else if (MyAngle<= 1 ) return (0.01745240643728);
   else if (MyAngle<= 2 ) return (0.03489949670250);
   else if (MyAngle<= 3 ) return (0.05233595624294);
   else if (MyAngle<= 4 ) return (0.06975647374413);
   else if (MyAngle<= 5 ) return (0.08715574274766);
   else if (MyAngle<= 6 ) return (0.10452846326765);
   else if (MyAngle<= 7 ) return (0.12186934340515);
   else if (MyAngle<= 8 ) return (0.13917310096007);
   else if (MyAngle<= 9 ) return (0.15643446504023);
   else if (MyAngle<= 10 ) return (0.17364817766693);
   else if (MyAngle<= 11 ) return (0.19080899537655);
   else if (MyAngle<= 12 ) return (0.20791169081776);
   else if (MyAngle<= 13 ) return (0.22495105434387);
   else if (MyAngle<= 14 ) return (0.24192189559967);
   else if (MyAngle<= 15 ) return (0.25881904510252);
   else if (MyAngle<= 16 ) return (0.27563735581700);
   else if (MyAngle<= 17 ) return (0.29237170472274);
   else if (MyAngle<= 18 ) return (0.30901699437495);
   else if (MyAngle<= 19 ) return (0.32556815445716);
   else if (MyAngle<= 20 ) return (0.34202014332567);
   else if (MyAngle<= 21 ) return (0.35836794954530);
   else if (MyAngle<= 22 ) return (0.37460659341591);
   else if (MyAngle<= 23 ) return (0.39073112848927);
   else if (MyAngle<= 24 ) return (0.40673664307580);
   else if (MyAngle<= 25 ) return (0.42261826174070);
   else if (MyAngle<= 26 ) return (0.43837114678908);
   else if (MyAngle<= 27 ) return (0.45399049973955);
   else if (MyAngle<= 28 ) return (0.46947156278589);
   else if (MyAngle<= 29 ) return (0.48480962024634);
   else if (MyAngle<= 30 ) return (0.50000000000000);
   else if (MyAngle<= 31 ) return (0.51503807491005);
   else if (MyAngle<= 32 ) return (0.52991926423320);
   else if (MyAngle<= 33 ) return (0.54463903501503);
   else if (MyAngle<= 34 ) return (0.55919290347075);
   else if (MyAngle<= 35 ) return (0.57357643635105);
   else if (MyAngle<= 36 ) return (0.58778525229247);
   else if (MyAngle<= 37 ) return (0.60181502315205);
   else if (MyAngle<= 38 ) return (0.61566147532566);
   else if (MyAngle<= 39 ) return (0.62932039104984);
   else if (MyAngle<= 40 ) return (0.64278760968654);
   else if (MyAngle<= 41 ) return (0.65605902899051);
   else if (MyAngle<= 42 ) return (0.66913060635886);
   else if (MyAngle<= 43 ) return (0.68199836006250);
   else if (MyAngle<= 44 ) return (0.69465837045900);
   else if (MyAngle<= 45 ) return (0.70710678118655);
   else if (MyAngle<= 46 ) return (0.71933980033865);
   else if (MyAngle<= 47 ) return (0.73135370161917);
   else if (MyAngle<= 48 ) return (0.74314482547739);
   else if (MyAngle<= 49 ) return (0.75470958022277);
   else if (MyAngle<= 50 ) return (0.76604444311898);
   else if (MyAngle<= 51 ) return (0.77714596145697);
   else if (MyAngle<= 52 ) return (0.78801075360672);
   else if (MyAngle<= 53 ) return (0.79863551004729);
   else if (MyAngle<= 54 ) return (0.80901699437495);
   else if (MyAngle<= 55 ) return (0.81915204428899);
   else if (MyAngle<= 56 ) return (0.82903757255504);
   else if (MyAngle<= 57 ) return (0.83867056794542);
   else if (MyAngle<= 58 ) return (0.84804809615643);
   else if (MyAngle<= 59 ) return (0.85716730070211);
   else if (MyAngle<= 60 ) return (0.86602540378444);
   else if (MyAngle<= 61 ) return (0.87461970713940);
   else if (MyAngle<= 62 ) return (0.88294759285893);
   else if (MyAngle<= 63 ) return (0.89100652418837);
   else if (MyAngle<= 64 ) return (0.89879404629917);
   else if (MyAngle<= 65 ) return (0.90630778703665);
   else if (MyAngle<= 66 ) return (0.91354545764260);
   else if (MyAngle<= 67 ) return (0.92050485345244);
   else if (MyAngle<= 68 ) return (0.92718385456679);
   else if (MyAngle<= 69 ) return (0.93358042649720);
   else if (MyAngle<= 70 ) return (0.93969262078591);
   else if (MyAngle<= 71 ) return (0.94551857559932);
   else if (MyAngle<= 72 ) return (0.95105651629515);
   else if (MyAngle<= 73 ) return (0.95630475596304);
   else if (MyAngle<= 74 ) return (0.96126169593832);
   else if (MyAngle<= 75 ) return (0.96592582628907);
   else if (MyAngle<= 76 ) return (0.97029572627600);
   else if (MyAngle<= 77 ) return (0.97437006478524);
   else if (MyAngle<= 78 ) return (0.97814760073381);
   else if (MyAngle<= 79 ) return (0.98162718344766);
   else if (MyAngle<= 80 ) return (0.98480775301221);
   else if (MyAngle<= 81 ) return (0.98768834059514);
   else if (MyAngle<= 82 ) return (0.99026806874157);
   else if (MyAngle<= 83 ) return (0.99254615164132);
   else if (MyAngle<= 84 ) return (0.99452189536827);
   else if (MyAngle<= 85 ) return (0.99619469809175);
   else if (MyAngle<= 86 ) return (0.99756405025982);
   else if (MyAngle<= 87 ) return (0.99862953475457);
   else if (MyAngle<= 88 ) return (0.99939082701910);
   else if (MyAngle<= 89 ) return (0.99984769515639);
   else if (MyAngle<= 90 ) return (1.00000000000000);
   else if (MyAngle<= 91 ) return (0.99984769515639);
   else if (MyAngle<= 92 ) return (0.99939082701910);
   else if (MyAngle<= 93 ) return (0.99862953475457);
   else if (MyAngle<= 94 ) return (0.99756405025982);
   else if (MyAngle<= 95 ) return (0.99619469809175);
   else if (MyAngle<= 96 ) return (0.99452189536827);
   else if (MyAngle<= 97 ) return (0.99254615164132);
   else if (MyAngle<= 98 ) return (0.99026806874157);
   else if (MyAngle<= 99 ) return (0.98768834059514);
   else if (MyAngle<= 100 ) return (0.98480775301221);
   else if (MyAngle<= 101 ) return (0.98162718344766);
   else if (MyAngle<= 102 ) return (0.97814760073381);
   else if (MyAngle<= 103 ) return (0.97437006478524);
   else if (MyAngle<= 104 ) return (0.97029572627600);
   else if (MyAngle<= 105 ) return (0.96592582628907);
   else if (MyAngle<= 106 ) return (0.96126169593832);
   else if (MyAngle<= 107 ) return (0.95630475596304);
   else if (MyAngle<= 108 ) return (0.95105651629515);
   else if (MyAngle<= 109 ) return (0.94551857559932);
   else if (MyAngle<= 110 ) return (0.93969262078591);
   else if (MyAngle<= 111 ) return (0.93358042649720);
   else if (MyAngle<= 112 ) return (0.92718385456679);
   else if (MyAngle<= 113 ) return (0.92050485345244);
   else if (MyAngle<= 114 ) return (0.91354545764260);
   else if (MyAngle<= 115 ) return (0.90630778703665);
   else if (MyAngle<= 116 ) return (0.89879404629917);
   else if (MyAngle<= 117 ) return (0.89100652418837);
   else if (MyAngle<= 118 ) return (0.88294759285893);
   else if (MyAngle<= 119 ) return (0.87461970713940);
   else if (MyAngle<= 120 ) return (0.86602540378444);
   else if (MyAngle<= 121 ) return (0.85716730070211);
   else if (MyAngle<= 122 ) return (0.84804809615643);
   else if (MyAngle<= 123 ) return (0.83867056794543);
   else if (MyAngle<= 124 ) return (0.82903757255504);
   else if (MyAngle<= 125 ) return (0.81915204428899);
   else if (MyAngle<= 126 ) return (0.80901699437495);
   else if (MyAngle<= 127 ) return (0.79863551004729);
   else if (MyAngle<= 128 ) return (0.78801075360672);
   else if (MyAngle<= 129 ) return (0.77714596145697);
   else if (MyAngle<= 130 ) return (0.76604444311898);
   else if (MyAngle<= 131 ) return (0.75470958022277);
   else if (MyAngle<= 132 ) return (0.74314482547740);
   else if (MyAngle<= 133 ) return (0.73135370161917);
   else if (MyAngle<= 134 ) return (0.71933980033865);
   else if (MyAngle<= 135 ) return (0.70710678118655);
   else if (MyAngle<= 136 ) return (0.69465837045900);
   else if (MyAngle<= 137 ) return (0.68199836006250);
   else if (MyAngle<= 138 ) return (0.66913060635886);
   else if (MyAngle<= 139 ) return (0.65605902899051);
   else if (MyAngle<= 140 ) return (0.64278760968654);
   else if (MyAngle<= 141 ) return (0.62932039104984);
   else if (MyAngle<= 142 ) return (0.61566147532566);
   else if (MyAngle<= 143 ) return (0.60181502315205);
   else if (MyAngle<= 144 ) return (0.58778525229248);
   else if (MyAngle<= 145 ) return (0.57357643635105);
   else if (MyAngle<= 146 ) return (0.55919290347075);
   else if (MyAngle<= 147 ) return (0.54463903501503);
   else if (MyAngle<= 148 ) return (0.52991926423321);
   else if (MyAngle<= 149 ) return (0.51503807491006);
   else if (MyAngle<= 150 ) return (0.50000000000000);
   else if (MyAngle<= 151 ) return (0.48480962024634);
   else if (MyAngle<= 152 ) return (0.46947156278589);
   else if (MyAngle<= 153 ) return (0.45399049973955);
   else if (MyAngle<= 154 ) return (0.43837114678908);
   else if (MyAngle<= 155 ) return (0.42261826174070);
   else if (MyAngle<= 156 ) return (0.40673664307580);
   else if (MyAngle<= 157 ) return (0.39073112848928);
   else if (MyAngle<= 158 ) return (0.37460659341592);
   else if (MyAngle<= 159 ) return (0.35836794954530);
   else if (MyAngle<= 160 ) return (0.34202014332567);
   else if (MyAngle<= 161 ) return (0.32556815445716);
   else if (MyAngle<= 162 ) return (0.30901699437495);
   else if (MyAngle<= 163 ) return (0.29237170472274);
   else if (MyAngle<= 164 ) return (0.27563735581700);
   else if (MyAngle<= 165 ) return (0.25881904510252);
   else if (MyAngle<= 166 ) return (0.24192189559967);
   else if (MyAngle<= 167 ) return (0.22495105434387);
   else if (MyAngle<= 168 ) return (0.20791169081776);
   else if (MyAngle<= 169 ) return (0.19080899537655);
   else if (MyAngle<= 170 ) return (0.17364817766693);
   else if (MyAngle<= 171 ) return (0.15643446504023);
   else if (MyAngle<= 172 ) return (0.13917310096007);
   else if (MyAngle<= 173 ) return (0.12186934340515);
   else if (MyAngle<= 174 ) return (0.10452846326766);
   else if (MyAngle<= 175 ) return (0.08715574274766);
   else if (MyAngle<= 176 ) return (0.06975647374413);
   else if (MyAngle<= 177 ) return (0.05233595624295);
   else if (MyAngle<= 178 ) return (0.03489949670250);
   else if (MyAngle<= 179 ) return (0.01745240643729);
   else if (MyAngle<= 180 ) return (0.00000000000000);
   else if (MyAngle<= 181 ) return (-0.01745240643728);
   else if (MyAngle<= 182 ) return (-0.03489949670250);
   else if (MyAngle<= 183 ) return (-0.05233595624294);
   else if (MyAngle<= 184 ) return (-0.06975647374412);
   else if (MyAngle<= 185 ) return (-0.08715574274765);
   else if (MyAngle<= 186 ) return (-0.10452846326765);
   else if (MyAngle<= 187 ) return (-0.12186934340514);
   else if (MyAngle<= 188 ) return (-0.13917310096006);
   else if (MyAngle<= 189 ) return (-0.15643446504023);
   else if (MyAngle<= 190 ) return (-0.17364817766693);
   else if (MyAngle<= 191 ) return (-0.19080899537654);
   else if (MyAngle<= 192 ) return (-0.20791169081776);
   else if (MyAngle<= 193 ) return (-0.22495105434386);
   else if (MyAngle<= 194 ) return (-0.24192189559966);
   else if (MyAngle<= 195 ) return (-0.25881904510252);
   else if (MyAngle<= 196 ) return (-0.27563735581700);
   else if (MyAngle<= 197 ) return (-0.29237170472273);
   else if (MyAngle<= 198 ) return (-0.30901699437494);
   else if (MyAngle<= 199 ) return (-0.32556815445715);
   else if (MyAngle<= 200 ) return (-0.34202014332567);
   else if (MyAngle<= 201 ) return (-0.35836794954530);
   else if (MyAngle<= 202 ) return (-0.37460659341591);
   else if (MyAngle<= 203 ) return (-0.39073112848927);
   else if (MyAngle<= 204 ) return (-0.40673664307580);
   else if (MyAngle<= 205 ) return (-0.42261826174070);
   else if (MyAngle<= 206 ) return (-0.43837114678907);
   else if (MyAngle<= 207 ) return (-0.45399049973954);
   else if (MyAngle<= 208 ) return (-0.46947156278589);
   else if (MyAngle<= 209 ) return (-0.48480962024633);
   else if (MyAngle<= 210 ) return (-0.50000000000000);
   else if (MyAngle<= 211 ) return (-0.51503807491005);
   else if (MyAngle<= 212 ) return (-0.52991926423320);
   else if (MyAngle<= 213 ) return (-0.54463903501502);
   else if (MyAngle<= 214 ) return (-0.55919290347074);
   else if (MyAngle<= 215 ) return (-0.57357643635104);
   else if (MyAngle<= 216 ) return (-0.58778525229247);
   else if (MyAngle<= 217 ) return (-0.60181502315205);
   else if (MyAngle<= 218 ) return (-0.61566147532566);
   else if (MyAngle<= 219 ) return (-0.62932039104984);
   else if (MyAngle<= 220 ) return (-0.64278760968654);
   else if (MyAngle<= 221 ) return (-0.65605902899050);
   else if (MyAngle<= 222 ) return (-0.66913060635886);
   else if (MyAngle<= 223 ) return (-0.68199836006250);
   else if (MyAngle<= 224 ) return (-0.69465837045899);
   else if (MyAngle<= 225 ) return (-0.70710678118655);
   else if (MyAngle<= 226 ) return (-0.71933980033865);
   else if (MyAngle<= 227 ) return (-0.73135370161917);
   else if (MyAngle<= 228 ) return (-0.74314482547739);
   else if (MyAngle<= 229 ) return (-0.75470958022277);
   else if (MyAngle<= 230 ) return (-0.76604444311898);
   else if (MyAngle<= 231 ) return (-0.77714596145697);
   else if (MyAngle<= 232 ) return (-0.78801075360672);
   else if (MyAngle<= 233 ) return (-0.79863551004729);
   else if (MyAngle<= 234 ) return (-0.80901699437495);
   else if (MyAngle<= 235 ) return (-0.81915204428899);
   else if (MyAngle<= 236 ) return (-0.82903757255504);
   else if (MyAngle<= 237 ) return (-0.83867056794542);
   else if (MyAngle<= 238 ) return (-0.84804809615642);
   else if (MyAngle<= 239 ) return (-0.85716730070211);
   else if (MyAngle<= 240 ) return (-0.86602540378444);
   else if (MyAngle<= 241 ) return (-0.87461970713939);
   else if (MyAngle<= 242 ) return (-0.88294759285893);
   else if (MyAngle<= 243 ) return (-0.89100652418837);
   else if (MyAngle<= 244 ) return (-0.89879404629917);
   else if (MyAngle<= 245 ) return (-0.90630778703665);
   else if (MyAngle<= 246 ) return (-0.91354545764260);
   else if (MyAngle<= 247 ) return (-0.92050485345244);
   else if (MyAngle<= 248 ) return (-0.92718385456679);
   else if (MyAngle<= 249 ) return (-0.93358042649720);
   else if (MyAngle<= 250 ) return (-0.93969262078591);
   else if (MyAngle<= 251 ) return (-0.94551857559932);
   else if (MyAngle<= 252 ) return (-0.95105651629515);
   else if (MyAngle<= 253 ) return (-0.95630475596303);
   else if (MyAngle<= 254 ) return (-0.96126169593832);
   else if (MyAngle<= 255 ) return (-0.96592582628907);
   else if (MyAngle<= 256 ) return (-0.97029572627600);
   else if (MyAngle<= 257 ) return (-0.97437006478523);
   else if (MyAngle<= 258 ) return (-0.97814760073381);
   else if (MyAngle<= 259 ) return (-0.98162718344766);
   else if (MyAngle<= 260 ) return (-0.98480775301221);
   else if (MyAngle<= 261 ) return (-0.98768834059514);
   else if (MyAngle<= 262 ) return (-0.99026806874157);
   else if (MyAngle<= 263 ) return (-0.99254615164132);
   else if (MyAngle<= 264 ) return (-0.99452189536827);
   else if (MyAngle<= 265 ) return (-0.99619469809175);
   else if (MyAngle<= 266 ) return (-0.99756405025982);
   else if (MyAngle<= 267 ) return (-0.99862953475457);
   else if (MyAngle<= 268 ) return (-0.99939082701910);
   else if (MyAngle<= 269 ) return (-0.99984769515639);
   else if (MyAngle<= 270 ) return (-1.00000000000000);
   else if (MyAngle<= 271 ) return (-0.99984769515639);
   else if (MyAngle<= 272 ) return (-0.99939082701910);
   else if (MyAngle<= 273 ) return (-0.99862953475457);
   else if (MyAngle<= 274 ) return (-0.99756405025983);
   else if (MyAngle<= 275 ) return (-0.99619469809175);
   else if (MyAngle<= 276 ) return (-0.99452189536827);
   else if (MyAngle<= 277 ) return (-0.99254615164132);
   else if (MyAngle<= 278 ) return (-0.99026806874157);
   else if (MyAngle<= 279 ) return (-0.98768834059514);
   else if (MyAngle<= 280 ) return (-0.98480775301221);
   else if (MyAngle<= 281 ) return (-0.98162718344767);
   else if (MyAngle<= 282 ) return (-0.97814760073381);
   else if (MyAngle<= 283 ) return (-0.97437006478524);
   else if (MyAngle<= 284 ) return (-0.97029572627600);
   else if (MyAngle<= 285 ) return (-0.96592582628907);
   else if (MyAngle<= 286 ) return (-0.96126169593832);
   else if (MyAngle<= 287 ) return (-0.95630475596304);
   else if (MyAngle<= 288 ) return (-0.95105651629516);
   else if (MyAngle<= 289 ) return (-0.94551857559932);
   else if (MyAngle<= 290 ) return (-0.93969262078591);
   else if (MyAngle<= 291 ) return (-0.93358042649720);
   else if (MyAngle<= 292 ) return (-0.92718385456679);
   else if (MyAngle<= 293 ) return (-0.92050485345244);
   else if (MyAngle<= 294 ) return (-0.91354545764260);
   else if (MyAngle<= 295 ) return (-0.90630778703665);
   else if (MyAngle<= 296 ) return (-0.89879404629917);
   else if (MyAngle<= 297 ) return (-0.89100652418837);
   else if (MyAngle<= 298 ) return (-0.88294759285893);
   else if (MyAngle<= 299 ) return (-0.87461970713940);
   else if (MyAngle<= 300 ) return (-0.86602540378444);
   else if (MyAngle<= 301 ) return (-0.85716730070212);
   else if (MyAngle<= 302 ) return (-0.84804809615643);
   else if (MyAngle<= 303 ) return (-0.83867056794543);
   else if (MyAngle<= 304 ) return (-0.82903757255505);
   else if (MyAngle<= 305 ) return (-0.81915204428900);
   else if (MyAngle<= 306 ) return (-0.80901699437495);
   else if (MyAngle<= 307 ) return (-0.79863551004730);
   else if (MyAngle<= 308 ) return (-0.78801075360673);
   else if (MyAngle<= 309 ) return (-0.77714596145697);
   else if (MyAngle<= 310 ) return (-0.76604444311898);
   else if (MyAngle<= 311 ) return (-0.75470958022278);
   else if (MyAngle<= 312 ) return (-0.74314482547740);
   else if (MyAngle<= 313 ) return (-0.73135370161918);
   else if (MyAngle<= 314 ) return (-0.71933980033866);
   else if (MyAngle<= 315 ) return (-0.70710678118655);
   else if (MyAngle<= 316 ) return (-0.69465837045900);
   else if (MyAngle<= 317 ) return (-0.68199836006250);
   else if (MyAngle<= 318 ) return (-0.66913060635886);
   else if (MyAngle<= 319 ) return (-0.65605902899051);
   else if (MyAngle<= 320 ) return (-0.64278760968654);
   else if (MyAngle<= 321 ) return (-0.62932039104984);
   else if (MyAngle<= 322 ) return (-0.61566147532566);
   else if (MyAngle<= 323 ) return (-0.60181502315205);
   else if (MyAngle<= 324 ) return (-0.58778525229248);
   else if (MyAngle<= 325 ) return (-0.57357643635105);
   else if (MyAngle<= 326 ) return (-0.55919290347075);
   else if (MyAngle<= 327 ) return (-0.54463903501503);
   else if (MyAngle<= 328 ) return (-0.52991926423321);
   else if (MyAngle<= 329 ) return (-0.51503807491006);
   else if (MyAngle<= 330 ) return (-0.50000000000001);
   else if (MyAngle<= 331 ) return (-0.48480962024634);
   else if (MyAngle<= 332 ) return (-0.46947156278590);
   else if (MyAngle<= 333 ) return (-0.45399049973955);
   else if (MyAngle<= 334 ) return (-0.43837114678908);
   else if (MyAngle<= 335 ) return (-0.42261826174071);
   else if (MyAngle<= 336 ) return (-0.40673664307581);
   else if (MyAngle<= 337 ) return (-0.39073112848928);
   else if (MyAngle<= 338 ) return (-0.37460659341592);
   else if (MyAngle<= 339 ) return (-0.35836794954531);
   else if (MyAngle<= 340 ) return (-0.34202014332567);
   else if (MyAngle<= 341 ) return (-0.32556815445716);
   else if (MyAngle<= 342 ) return (-0.30901699437495);
   else if (MyAngle<= 343 ) return (-0.29237170472274);
   else if (MyAngle<= 344 ) return (-0.27563735581701);
   else if (MyAngle<= 345 ) return (-0.25881904510253);
   else if (MyAngle<= 346 ) return (-0.24192189559967);
   else if (MyAngle<= 347 ) return (-0.22495105434387);
   else if (MyAngle<= 348 ) return (-0.20791169081777);
   else if (MyAngle<= 349 ) return (-0.19080899537655);
   else if (MyAngle<= 350 ) return (-0.17364817766694);
   else if (MyAngle<= 351 ) return (-0.15643446504024);
   else if (MyAngle<= 352 ) return (-0.13917310096007);
   else if (MyAngle<= 353 ) return (-0.12186934340515);
   else if (MyAngle<= 354 ) return (-0.10452846326766);
   else if (MyAngle<= 355 ) return (-0.08715574274766);
   else if (MyAngle<= 356 ) return (-0.06975647374413);
   else if (MyAngle<= 357 ) return (-0.05233595624295);
   else if (MyAngle<= 358 ) return (-0.03489949670251);
   else if (MyAngle<= 359 ) return (-0.01745240643729);
   else if (MyAngle<= 360 ) return (-0.00000000000001);

}
float cos(float Angle=0) {
   float MyAngle=(Angle+360) % 360;
   if (MyAngle<= 0 ) return (1.00000000000000);
   else if (MyAngle<= 1 ) return (0.99984769515639);
   else if (MyAngle<= 2 ) return (0.99939082701910);
   else if (MyAngle<= 3 ) return (0.99862953475457);
   else if (MyAngle<= 4 ) return (0.99756405025982);
   else if (MyAngle<= 5 ) return (0.99619469809175);
   else if (MyAngle<= 6 ) return (0.99452189536827);
   else if (MyAngle<= 7 ) return (0.99254615164132);
   else if (MyAngle<= 8 ) return (0.99026806874157);
   else if (MyAngle<= 9 ) return (0.98768834059514);
   else if (MyAngle<= 10 ) return (0.98480775301221);
   else if (MyAngle<= 11 ) return (0.98162718344766);
   else if (MyAngle<= 12 ) return (0.97814760073381);
   else if (MyAngle<= 13 ) return (0.97437006478524);
   else if (MyAngle<= 14 ) return (0.97029572627600);
   else if (MyAngle<= 15 ) return (0.96592582628907);
   else if (MyAngle<= 16 ) return (0.96126169593832);
   else if (MyAngle<= 17 ) return (0.95630475596304);
   else if (MyAngle<= 18 ) return (0.95105651629515);
   else if (MyAngle<= 19 ) return (0.94551857559932);
   else if (MyAngle<= 20 ) return (0.93969262078591);
   else if (MyAngle<= 21 ) return (0.93358042649720);
   else if (MyAngle<= 22 ) return (0.92718385456679);
   else if (MyAngle<= 23 ) return (0.92050485345244);
   else if (MyAngle<= 24 ) return (0.91354545764260);
   else if (MyAngle<= 25 ) return (0.90630778703665);
   else if (MyAngle<= 26 ) return (0.89879404629917);
   else if (MyAngle<= 27 ) return (0.89100652418837);
   else if (MyAngle<= 28 ) return (0.88294759285893);
   else if (MyAngle<= 29 ) return (0.87461970713940);
   else if (MyAngle<= 30 ) return (0.86602540378444);
   else if (MyAngle<= 31 ) return (0.85716730070211);
   else if (MyAngle<= 32 ) return (0.84804809615643);
   else if (MyAngle<= 33 ) return (0.83867056794542);
   else if (MyAngle<= 34 ) return (0.82903757255504);
   else if (MyAngle<= 35 ) return (0.81915204428899);
   else if (MyAngle<= 36 ) return (0.80901699437495);
   else if (MyAngle<= 37 ) return (0.79863551004729);
   else if (MyAngle<= 38 ) return (0.78801075360672);
   else if (MyAngle<= 39 ) return (0.77714596145697);
   else if (MyAngle<= 40 ) return (0.76604444311898);
   else if (MyAngle<= 41 ) return (0.75470958022277);
   else if (MyAngle<= 42 ) return (0.74314482547740);
   else if (MyAngle<= 43 ) return (0.73135370161917);
   else if (MyAngle<= 44 ) return (0.71933980033865);
   else if (MyAngle<= 45 ) return (0.70710678118655);
   else if (MyAngle<= 46 ) return (0.69465837045900);
   else if (MyAngle<= 47 ) return (0.68199836006250);
   else if (MyAngle<= 48 ) return (0.66913060635886);
   else if (MyAngle<= 49 ) return (0.65605902899051);
   else if (MyAngle<= 50 ) return (0.64278760968654);
   else if (MyAngle<= 51 ) return (0.62932039104984);
   else if (MyAngle<= 52 ) return (0.61566147532566);
   else if (MyAngle<= 53 ) return (0.60181502315205);
   else if (MyAngle<= 54 ) return (0.58778525229247);
   else if (MyAngle<= 55 ) return (0.57357643635105);
   else if (MyAngle<= 56 ) return (0.55919290347075);
   else if (MyAngle<= 57 ) return (0.54463903501503);
   else if (MyAngle<= 58 ) return (0.52991926423321);
   else if (MyAngle<= 59 ) return (0.51503807491006);
   else if (MyAngle<= 60 ) return (0.50000000000000);
   else if (MyAngle<= 61 ) return (0.48480962024634);
   else if (MyAngle<= 62 ) return (0.46947156278589);
   else if (MyAngle<= 63 ) return (0.45399049973955);
   else if (MyAngle<= 64 ) return (0.43837114678908);
   else if (MyAngle<= 65 ) return (0.42261826174070);
   else if (MyAngle<= 66 ) return (0.40673664307580);
   else if (MyAngle<= 67 ) return (0.39073112848928);
   else if (MyAngle<= 68 ) return (0.37460659341591);
   else if (MyAngle<= 69 ) return (0.35836794954530);
   else if (MyAngle<= 70 ) return (0.34202014332567);
   else if (MyAngle<= 71 ) return (0.32556815445716);
   else if (MyAngle<= 72 ) return (0.30901699437495);
   else if (MyAngle<= 73 ) return (0.29237170472274);
   else if (MyAngle<= 74 ) return (0.27563735581700);
   else if (MyAngle<= 75 ) return (0.25881904510252);
   else if (MyAngle<= 76 ) return (0.24192189559967);
   else if (MyAngle<= 77 ) return (0.22495105434387);
   else if (MyAngle<= 78 ) return (0.20791169081776);
   else if (MyAngle<= 79 ) return (0.19080899537655);
   else if (MyAngle<= 80 ) return (0.17364817766693);
   else if (MyAngle<= 81 ) return (0.15643446504023);
   else if (MyAngle<= 82 ) return (0.13917310096007);
   else if (MyAngle<= 83 ) return (0.12186934340515);
   else if (MyAngle<= 84 ) return (0.10452846326766);
   else if (MyAngle<= 85 ) return (0.08715574274766);
   else if (MyAngle<= 86 ) return (0.06975647374413);
   else if (MyAngle<= 87 ) return (0.05233595624295);
   else if (MyAngle<= 88 ) return (0.03489949670250);
   else if (MyAngle<= 89 ) return (0.01745240643729);
   else if (MyAngle<= 90 ) return (0.00000000000000);
   else if (MyAngle<= 91 ) return (-0.01745240643728);
   else if (MyAngle<= 92 ) return (-0.03489949670250);
   else if (MyAngle<= 93 ) return (-0.05233595624294);
   else if (MyAngle<= 94 ) return (-0.06975647374412);
   else if (MyAngle<= 95 ) return (-0.08715574274766);
   else if (MyAngle<= 96 ) return (-0.10452846326765);
   else if (MyAngle<= 97 ) return (-0.12186934340515);
   else if (MyAngle<= 98 ) return (-0.13917310096006);
   else if (MyAngle<= 99 ) return (-0.15643446504023);
   else if (MyAngle<= 100 ) return (-0.17364817766693);
   else if (MyAngle<= 101 ) return (-0.19080899537654);
   else if (MyAngle<= 102 ) return (-0.20791169081776);
   else if (MyAngle<= 103 ) return (-0.22495105434386);
   else if (MyAngle<= 104 ) return (-0.24192189559967);
   else if (MyAngle<= 105 ) return (-0.25881904510252);
   else if (MyAngle<= 106 ) return (-0.27563735581700);
   else if (MyAngle<= 107 ) return (-0.29237170472274);
   else if (MyAngle<= 108 ) return (-0.30901699437495);
   else if (MyAngle<= 109 ) return (-0.32556815445716);
   else if (MyAngle<= 110 ) return (-0.34202014332567);
   else if (MyAngle<= 111 ) return (-0.35836794954530);
   else if (MyAngle<= 112 ) return (-0.37460659341591);
   else if (MyAngle<= 113 ) return (-0.39073112848927);
   else if (MyAngle<= 114 ) return (-0.40673664307580);
   else if (MyAngle<= 115 ) return (-0.42261826174070);
   else if (MyAngle<= 116 ) return (-0.43837114678908);
   else if (MyAngle<= 117 ) return (-0.45399049973955);
   else if (MyAngle<= 118 ) return (-0.46947156278589);
   else if (MyAngle<= 119 ) return (-0.48480962024634);
   else if (MyAngle<= 120 ) return (-0.50000000000000);
   else if (MyAngle<= 121 ) return (-0.51503807491005);
   else if (MyAngle<= 122 ) return (-0.52991926423320);
   else if (MyAngle<= 123 ) return (-0.54463903501503);
   else if (MyAngle<= 124 ) return (-0.55919290347075);
   else if (MyAngle<= 125 ) return (-0.57357643635104);
   else if (MyAngle<= 126 ) return (-0.58778525229247);
   else if (MyAngle<= 127 ) return (-0.60181502315205);
   else if (MyAngle<= 128 ) return (-0.61566147532566);
   else if (MyAngle<= 129 ) return (-0.62932039104984);
   else if (MyAngle<= 130 ) return (-0.64278760968654);
   else if (MyAngle<= 131 ) return (-0.65605902899051);
   else if (MyAngle<= 132 ) return (-0.66913060635886);
   else if (MyAngle<= 133 ) return (-0.68199836006250);
   else if (MyAngle<= 134 ) return (-0.69465837045900);
   else if (MyAngle<= 135 ) return (-0.70710678118655);
   else if (MyAngle<= 136 ) return (-0.71933980033865);
   else if (MyAngle<= 137 ) return (-0.73135370161917);
   else if (MyAngle<= 138 ) return (-0.74314482547739);
   else if (MyAngle<= 139 ) return (-0.75470958022277);
   else if (MyAngle<= 140 ) return (-0.76604444311898);
   else if (MyAngle<= 141 ) return (-0.77714596145697);
   else if (MyAngle<= 142 ) return (-0.78801075360672);
   else if (MyAngle<= 143 ) return (-0.79863551004729);
   else if (MyAngle<= 144 ) return (-0.80901699437495);
   else if (MyAngle<= 145 ) return (-0.81915204428899);
   else if (MyAngle<= 146 ) return (-0.82903757255504);
   else if (MyAngle<= 147 ) return (-0.83867056794542);
   else if (MyAngle<= 148 ) return (-0.84804809615643);
   else if (MyAngle<= 149 ) return (-0.85716730070211);
   else if (MyAngle<= 150 ) return (-0.86602540378444);
   else if (MyAngle<= 151 ) return (-0.87461970713939);
   else if (MyAngle<= 152 ) return (-0.88294759285893);
   else if (MyAngle<= 153 ) return (-0.89100652418837);
   else if (MyAngle<= 154 ) return (-0.89879404629917);
   else if (MyAngle<= 155 ) return (-0.90630778703665);
   else if (MyAngle<= 156 ) return (-0.91354545764260);
   else if (MyAngle<= 157 ) return (-0.92050485345244);
   else if (MyAngle<= 158 ) return (-0.92718385456679);
   else if (MyAngle<= 159 ) return (-0.93358042649720);
   else if (MyAngle<= 160 ) return (-0.93969262078591);
   else if (MyAngle<= 161 ) return (-0.94551857559932);
   else if (MyAngle<= 162 ) return (-0.95105651629515);
   else if (MyAngle<= 163 ) return (-0.95630475596304);
   else if (MyAngle<= 164 ) return (-0.96126169593832);
   else if (MyAngle<= 165 ) return (-0.96592582628907);
   else if (MyAngle<= 166 ) return (-0.97029572627600);
   else if (MyAngle<= 167 ) return (-0.97437006478524);
   else if (MyAngle<= 168 ) return (-0.97814760073381);
   else if (MyAngle<= 169 ) return (-0.98162718344766);
   else if (MyAngle<= 170 ) return (-0.98480775301221);
   else if (MyAngle<= 171 ) return (-0.98768834059514);
   else if (MyAngle<= 172 ) return (-0.99026806874157);
   else if (MyAngle<= 173 ) return (-0.99254615164132);
   else if (MyAngle<= 174 ) return (-0.99452189536827);
   else if (MyAngle<= 175 ) return (-0.99619469809175);
   else if (MyAngle<= 176 ) return (-0.99756405025982);
   else if (MyAngle<= 177 ) return (-0.99862953475457);
   else if (MyAngle<= 178 ) return (-0.99939082701910);
   else if (MyAngle<= 179 ) return (-0.99984769515639);
   else if (MyAngle<= 180 ) return (-1.00000000000000);
   else if (MyAngle<= 181 ) return (-0.99984769515639);
   else if (MyAngle<= 182 ) return (-0.99939082701910);
   else if (MyAngle<= 183 ) return (-0.99862953475457);
   else if (MyAngle<= 184 ) return (-0.99756405025982);
   else if (MyAngle<= 185 ) return (-0.99619469809175);
   else if (MyAngle<= 186 ) return (-0.99452189536827);
   else if (MyAngle<= 187 ) return (-0.99254615164132);
   else if (MyAngle<= 188 ) return (-0.99026806874157);
   else if (MyAngle<= 189 ) return (-0.98768834059514);
   else if (MyAngle<= 190 ) return (-0.98480775301221);
   else if (MyAngle<= 191 ) return (-0.98162718344767);
   else if (MyAngle<= 192 ) return (-0.97814760073381);
   else if (MyAngle<= 193 ) return (-0.97437006478524);
   else if (MyAngle<= 194 ) return (-0.97029572627600);
   else if (MyAngle<= 195 ) return (-0.96592582628907);
   else if (MyAngle<= 196 ) return (-0.96126169593832);
   else if (MyAngle<= 197 ) return (-0.95630475596304);
   else if (MyAngle<= 198 ) return (-0.95105651629516);
   else if (MyAngle<= 199 ) return (-0.94551857559932);
   else if (MyAngle<= 200 ) return (-0.93969262078591);
   else if (MyAngle<= 201 ) return (-0.93358042649720);
   else if (MyAngle<= 202 ) return (-0.92718385456679);
   else if (MyAngle<= 203 ) return (-0.92050485345244);
   else if (MyAngle<= 204 ) return (-0.91354545764260);
   else if (MyAngle<= 205 ) return (-0.90630778703665);
   else if (MyAngle<= 206 ) return (-0.89879404629917);
   else if (MyAngle<= 207 ) return (-0.89100652418837);
   else if (MyAngle<= 208 ) return (-0.88294759285893);
   else if (MyAngle<= 209 ) return (-0.87461970713940);
   else if (MyAngle<= 210 ) return (-0.86602540378444);
   else if (MyAngle<= 211 ) return (-0.85716730070211);
   else if (MyAngle<= 212 ) return (-0.84804809615643);
   else if (MyAngle<= 213 ) return (-0.83867056794543);
   else if (MyAngle<= 214 ) return (-0.82903757255504);
   else if (MyAngle<= 215 ) return (-0.81915204428899);
   else if (MyAngle<= 216 ) return (-0.80901699437495);
   else if (MyAngle<= 217 ) return (-0.79863551004730);
   else if (MyAngle<= 218 ) return (-0.78801075360672);
   else if (MyAngle<= 219 ) return (-0.77714596145697);
   else if (MyAngle<= 220 ) return (-0.76604444311898);
   else if (MyAngle<= 221 ) return (-0.75470958022277);
   else if (MyAngle<= 222 ) return (-0.74314482547740);
   else if (MyAngle<= 223 ) return (-0.73135370161917);
   else if (MyAngle<= 224 ) return (-0.71933980033865);
   else if (MyAngle<= 225 ) return (-0.70710678118655);
   else if (MyAngle<= 226 ) return (-0.69465837045900);
   else if (MyAngle<= 227 ) return (-0.68199836006250);
   else if (MyAngle<= 228 ) return (-0.66913060635886);
   else if (MyAngle<= 229 ) return (-0.65605902899051);
   else if (MyAngle<= 230 ) return (-0.64278760968654);
   else if (MyAngle<= 231 ) return (-0.62932039104984);
   else if (MyAngle<= 232 ) return (-0.61566147532566);
   else if (MyAngle<= 233 ) return (-0.60181502315205);
   else if (MyAngle<= 234 ) return (-0.58778525229248);
   else if (MyAngle<= 235 ) return (-0.57357643635105);
   else if (MyAngle<= 236 ) return (-0.55919290347075);
   else if (MyAngle<= 237 ) return (-0.54463903501503);
   else if (MyAngle<= 238 ) return (-0.52991926423321);
   else if (MyAngle<= 239 ) return (-0.51503807491006);
   else if (MyAngle<= 240 ) return (-0.50000000000000);
   else if (MyAngle<= 241 ) return (-0.48480962024634);
   else if (MyAngle<= 242 ) return (-0.46947156278590);
   else if (MyAngle<= 243 ) return (-0.45399049973955);
   else if (MyAngle<= 244 ) return (-0.43837114678908);
   else if (MyAngle<= 245 ) return (-0.42261826174070);
   else if (MyAngle<= 246 ) return (-0.40673664307580);
   else if (MyAngle<= 247 ) return (-0.39073112848928);
   else if (MyAngle<= 248 ) return (-0.37460659341592);
   else if (MyAngle<= 249 ) return (-0.35836794954531);
   else if (MyAngle<= 250 ) return (-0.34202014332567);
   else if (MyAngle<= 251 ) return (-0.32556815445716);
   else if (MyAngle<= 252 ) return (-0.30901699437495);
   else if (MyAngle<= 253 ) return (-0.29237170472274);
   else if (MyAngle<= 254 ) return (-0.27563735581700);
   else if (MyAngle<= 255 ) return (-0.25881904510253);
   else if (MyAngle<= 256 ) return (-0.24192189559967);
   else if (MyAngle<= 257 ) return (-0.22495105434387);
   else if (MyAngle<= 258 ) return (-0.20791169081776);
   else if (MyAngle<= 259 ) return (-0.19080899537655);
   else if (MyAngle<= 260 ) return (-0.17364817766694);
   else if (MyAngle<= 261 ) return (-0.15643446504024);
   else if (MyAngle<= 262 ) return (-0.13917310096007);
   else if (MyAngle<= 263 ) return (-0.12186934340515);
   else if (MyAngle<= 264 ) return (-0.10452846326766);
   else if (MyAngle<= 265 ) return (-0.08715574274766);
   else if (MyAngle<= 266 ) return (-0.06975647374413);
   else if (MyAngle<= 267 ) return (-0.05233595624295);
   else if (MyAngle<= 268 ) return (-0.03489949670251);
   else if (MyAngle<= 269 ) return (-0.01745240643729);
   else if (MyAngle<= 270 ) return (0.00000000000000);
   else if (MyAngle<= 271 ) return (0.01745240643728);
   else if (MyAngle<= 272 ) return (0.03489949670250);
   else if (MyAngle<= 273 ) return (0.05233595624294);
   else if (MyAngle<= 274 ) return (0.06975647374412);
   else if (MyAngle<= 275 ) return (0.08715574274765);
   else if (MyAngle<= 276 ) return (0.10452846326765);
   else if (MyAngle<= 277 ) return (0.12186934340514);
   else if (MyAngle<= 278 ) return (0.13917310096006);
   else if (MyAngle<= 279 ) return (0.15643446504023);
   else if (MyAngle<= 280 ) return (0.17364817766693);
   else if (MyAngle<= 281 ) return (0.19080899537654);
   else if (MyAngle<= 282 ) return (0.20791169081775);
   else if (MyAngle<= 283 ) return (0.22495105434386);
   else if (MyAngle<= 284 ) return (0.24192189559966);
   else if (MyAngle<= 285 ) return (0.25881904510252);
   else if (MyAngle<= 286 ) return (0.27563735581699);
   else if (MyAngle<= 287 ) return (0.29237170472273);
   else if (MyAngle<= 288 ) return (0.30901699437494);
   else if (MyAngle<= 289 ) return (0.32556815445715);
   else if (MyAngle<= 290 ) return (0.34202014332566);
   else if (MyAngle<= 291 ) return (0.35836794954530);
   else if (MyAngle<= 292 ) return (0.37460659341591);
   else if (MyAngle<= 293 ) return (0.39073112848927);
   else if (MyAngle<= 294 ) return (0.40673664307580);
   else if (MyAngle<= 295 ) return (0.42261826174070);
   else if (MyAngle<= 296 ) return (0.43837114678907);
   else if (MyAngle<= 297 ) return (0.45399049973954);
   else if (MyAngle<= 298 ) return (0.46947156278589);
   else if (MyAngle<= 299 ) return (0.48480962024633);
   else if (MyAngle<= 300 ) return (0.50000000000000);
   else if (MyAngle<= 301 ) return (0.51503807491005);
   else if (MyAngle<= 302 ) return (0.52991926423320);
   else if (MyAngle<= 303 ) return (0.54463903501502);
   else if (MyAngle<= 304 ) return (0.55919290347074);
   else if (MyAngle<= 305 ) return (0.57357643635104);
   else if (MyAngle<= 306 ) return (0.58778525229247);
   else if (MyAngle<= 307 ) return (0.60181502315204);
   else if (MyAngle<= 308 ) return (0.61566147532565);
   else if (MyAngle<= 309 ) return (0.62932039104983);
   else if (MyAngle<= 310 ) return (0.64278760968654);
   else if (MyAngle<= 311 ) return (0.65605902899050);
   else if (MyAngle<= 312 ) return (0.66913060635885);
   else if (MyAngle<= 313 ) return (0.68199836006249);
   else if (MyAngle<= 314 ) return (0.69465837045899);
   else if (MyAngle<= 315 ) return (0.70710678118654);
   else if (MyAngle<= 316 ) return (0.71933980033865);
   else if (MyAngle<= 317 ) return (0.73135370161917);
   else if (MyAngle<= 318 ) return (0.74314482547739);
   else if (MyAngle<= 319 ) return (0.75470958022277);
   else if (MyAngle<= 320 ) return (0.76604444311897);
   else if (MyAngle<= 321 ) return (0.77714596145697);
   else if (MyAngle<= 322 ) return (0.78801075360672);
   else if (MyAngle<= 323 ) return (0.79863551004729);
   else if (MyAngle<= 324 ) return (0.80901699437494);
   else if (MyAngle<= 325 ) return (0.81915204428899);
   else if (MyAngle<= 326 ) return (0.82903757255504);
   else if (MyAngle<= 327 ) return (0.83867056794542);
   else if (MyAngle<= 328 ) return (0.84804809615642);
   else if (MyAngle<= 329 ) return (0.85716730070211);
   else if (MyAngle<= 330 ) return (0.86602540378444);
   else if (MyAngle<= 331 ) return (0.87461970713939);
   else if (MyAngle<= 332 ) return (0.88294759285892);
   else if (MyAngle<= 333 ) return (0.89100652418837);
   else if (MyAngle<= 334 ) return (0.89879404629916);
   else if (MyAngle<= 335 ) return (0.90630778703665);
   else if (MyAngle<= 336 ) return (0.91354545764260);
   else if (MyAngle<= 337 ) return (0.92050485345244);
   else if (MyAngle<= 338 ) return (0.92718385456679);
   else if (MyAngle<= 339 ) return (0.93358042649720);
   else if (MyAngle<= 340 ) return (0.93969262078591);
   else if (MyAngle<= 341 ) return (0.94551857559932);
   else if (MyAngle<= 342 ) return (0.95105651629515);
   else if (MyAngle<= 343 ) return (0.95630475596303);
   else if (MyAngle<= 344 ) return (0.96126169593832);
   else if (MyAngle<= 345 ) return (0.96592582628907);
   else if (MyAngle<= 346 ) return (0.97029572627600);
   else if (MyAngle<= 347 ) return (0.97437006478523);
   else if (MyAngle<= 348 ) return (0.97814760073380);
   else if (MyAngle<= 349 ) return (0.98162718344766);
   else if (MyAngle<= 350 ) return (0.98480775301221);
   else if (MyAngle<= 351 ) return (0.98768834059514);
   else if (MyAngle<= 352 ) return (0.99026806874157);
   else if (MyAngle<= 353 ) return (0.99254615164132);
   else if (MyAngle<= 354 ) return (0.99452189536827);
   else if (MyAngle<= 355 ) return (0.99619469809175);
   else if (MyAngle<= 356 ) return (0.99756405025982);
   else if (MyAngle<= 357 ) return (0.99862953475457);
   else if (MyAngle<= 358 ) return (0.99939082701910);
   else if (MyAngle<= 359 ) return (0.99984769515639);
   else if (MyAngle<= 360 ) return (1.00000000000000);
}
float GetXPointOnCircle(float Angle=0, float Radius=0, float AtX=.5) {
   float MyX = (Radius * cos(Angle) + AtX); // FIND X AT CIRCLES EDGE
   MyX = iifF(MyX<0,0,MyX);
   MyX = iifF(MyX>1,1,MyX);
   return (MyX);
}
float GetZPointOnCircle(float Angle=0, float Radius=0, float AtZ=.5) {
   float MyZ = (Radius * sin(Angle) + AtZ); // FIND Z AT CIRCLES EDGE
   MyZ = iifF(MyZ<0,0,MyZ);
   MyZ = iifF(MyZ>1,1,MyZ);
   return (MyZ);
}

int ObjectsInACircle(int id=0, float StartAngle=0, float EndAngle=0, float AngleBetween=0, float Radius=0, float StartX=.5, float StartZ=.5, int PlayerId=0, int Count=0) {
   // RADIUS AS FRACTION, WIDTH IN METERS
   float ThisAngle=iifF(EndAngle<StartAngle,(EndAngle+360)-StartAngle,EndAngle-StartAngle);
   int NumberOfAngles = (ThisAngle)/AngleBetween; // NUMBER OF ANGLES BETWEEN
   ThisAngle = StartAngle;
   for (i=0; <=NumberOfAngles) {
      float MyAtX=GetXPointOnCircle(ThisAngle, Radius, StartX);
      float MyAtZ=GetZPointOnCircle(ThisAngle, Radius, StartZ);
      ThisAngle=ThisAngle+AngleBetween;
      rmPlaceObjectDefAtLoc(id, PlayerId, MyAtX, MyAtZ, Count);
   }
   return(id);
}

string playerSpawnMoveLoc(int i=1) {
   int slot=getSlot(i);
   int ThisAngle=(360/myNumPlayers * (slot-1));
   float MyAtX=GetXPointOnCircle(ThisAngle, KillLoc, .5);
   float MyAtZ=GetZPointOnCircle(ThisAngle, KillLoc, .5);
   return(pointLoc(MyAtX,MyAtZ));
}
string playerSpawnLoc(int i=1) {
   int slot=getSlot(i);
   int ThisAngle=(360/myNumPlayers * (slot-1));
   float MyAtX=GetXPointOnCircle(ThisAngle, KillLoc+.038, .5);
   float MyAtZ=GetZPointOnCircle(ThisAngle, KillLoc+.038, .5);
   return(pointLoc(MyAtX,MyAtZ));
}

string playerGiftLoc(int i=1) {
   int slot=getSlot(i);
   int ThisAngle=(360/myNumPlayers * (slot-1));
   float MyAtX=GetXPointOnCircle(ThisAngle, .45, .5);
   float MyAtZ=GetZPointOnCircle(ThisAngle, .45, .5);
   return(pointLoc(MyAtX,MyAtZ));
}

string RandomSFX() {
   if (rmRandInt(0,1)==1)
      return (chooseRandString("Ragnorok SFX","Einheriar Boost SFX","Hero Birth","Hero Death","Poison SFX"));
   else
      return (chooseRandString("Arkantos Boost SFX","Lightning Sparks","Regeneration SFX"));
}

void LostGameKillTrig(string name="", int i=0) {
   rmSwitchToTrigger(rmTriggerID("PlayerLost_"+i));
   rmAddTriggerEffect("Disable Trigger");
   rmSetTriggerEffectParam("TrigName", name);
}

void BuildTax() { // GIVE PLAYERS AN INCENTIVE TO NOT REPAIR TC
   for(i=1; <cNumberPlayers) {
      int id = rmCreateTrigger("BuildTax_"+i);
      rmSwitchToTrigger(id);
      rmSetTriggerLoop(true);
      rmSetTriggerPriority(3);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 5, false);
      rmAddTriggerCondition("Player Is Building");
      rmSetTriggerConditionParam("ProtoUnit", PlayerBase);
      rmSetTriggerConditionParamInt("PlayerID", i);
      rmSetTriggerConditionParam("Op", "==");
      rmSetTriggerConditionParamInt("Count", 1);
      SendChat("Player "+i+" is building a house!");
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "gold", false);
      rmSetTriggerEffectParamInt("Amount", -100, false);
      LostGameKillTrig("BuildTax_"+i,i);
   }
}

void PlayerLost() {
   for(i=1; <cNumberPlayers) {
      int id = rmCreateTrigger("PlayerLost_"+i); // DEATH TOLL
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Player Unit Count");
      rmSetTriggerConditionParam("ProtoUnit", PlayerBase);
      rmSetTriggerConditionParamInt("PlayerID", i);
      rmSetTriggerConditionParam("Op", "==");
      rmSetTriggerConditionParamInt("Count", 0);
      rmAddTriggerEffect("Message");
      rmSetTriggerEffectParamInt("Timeout", 6000, false);
      rmSetTriggerEffectParam("Text", "****** Spill Blood by TwentyOneScore@BeerInHand.com ****** .....Thanks.Matei.&.M0nty.Pyth0n.for.wisdom.&.code.samples...", false);
      SendChat("Player "+i+" has been defeated.", i);
      rmAddTriggerEffect("Player Destroy All Buildings");
      rmSetTriggerEffectParamInt("Player", i, false);
      rmAddTriggerEffect("Sound Filename");
      rmSetTriggerEffectParam("Sound", "\dialog\skul062.mp3", false);
      rmAddTriggerEffect("Set Player Defeated");
      rmSetTriggerEffectParamInt("Player", i, false);
   }
}


void addStartingUnit(string name="", int i=0, float MyAtX=0, float MyAtZ=0, float MyAtX2=0, float MyAtZ2=0, int count=0) {
   // starting units
/*
   int id = rmCreateTrigger("StartingUnit_"+count+name+"_p"+i);
   rmSwitchToTrigger(id);
   rmSetTriggerLoop(false);
   rmSetTriggerPriority(3);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 2, false);
*/
   rmSwitchToTrigger(rmTriggerID("RunASAP"));
   rmAddTriggerEffect("Army Deploy");
   rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
   rmSetTriggerEffectParam("ProtoName", name, false);
   rmSetTriggerEffectParamInt("Count", 1, false);
   rmSetTriggerEffectParamInt("Heading", 0, false);
   rmSetTriggerEffectParam("Clear", "true", false);
   rmSetTriggerEffectParam("Location", pointLoc(MyAtX,MyAtZ), false);
   rmAddTriggerEffect("Army Move");
   rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
   rmSetTriggerEffectParam("DstPoint", pointLoc(MyAtX2,MyAtZ2), false);
   rmSetTriggerEffectParam("AttackMove", "true", false);
   rmAddTriggerEffect("Army Deploy");
   rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
   rmSetTriggerEffectParam("ProtoName", RandomSFX(), false);
   rmSetTriggerEffectParamInt("Count", 1, false);
   rmSetTriggerEffectParamInt("Heading", 0, false);
   rmSetTriggerEffectParam("Clear", "true", false);
   rmSetTriggerEffectParam("Location", pointLoc(MyAtX,MyAtZ), false);
}

void addSpawningUnit(string trigname="", string name="", int count=0, int time=0, int favor=0, int cult=0, int maxCount=0) {
   int myTime = time * (cMapSize+1);
   string hsid="";
   for(i=1; <cNumberPlayers) {
      if (cult==cCultureGreek) hsid=getHotSpot_G(i);
      else if (cult==cCultureNorse) hsid=getHotSpot_N(i);
      else hsid=getHotSpot_E(i);

      int id = rmCreateTrigger("fav"+favor+"_"+trigname+"_p"+i);
      rmSwitchToTrigger(id);
      rmSetTriggerLoop(true);
      rmSetTriggerPriority(3);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", myTime, false);
      rmAddTriggerCondition("Player Resource Count");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("Resource", "favor", false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamInt("Count", favor, false);
      rmAddTriggerCondition("Player Population");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("Op", "<", false);
      rmSetTriggerConditionParamInt("Count", POP_LIMIT, false);
      rmAddTriggerCondition("Units In Area");
      rmSetTriggerConditionParamInt("Player", i, false);
      rmSetTriggerConditionParam("DstObject", hsid, false);
      rmSetTriggerConditionParam("UnitType", CivPicker, false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamFloat("Dist", 5, false);
      rmSetTriggerConditionParamInt("Count", 1, false);
      if (maxCount>0) {
         rmAddTriggerCondition("Player Unit Count");
         rmSetTriggerConditionParam("ProtoUnit", name);
         rmSetTriggerConditionParamInt("PlayerID", i);
         rmSetTriggerConditionParam("Op", "<=");
         rmSetTriggerConditionParamInt("Count", maxCount);
      }
      rmAddTriggerCondition("Player Unit Count");
      rmSetTriggerConditionParam("ProtoUnit", "Wall Short");
      rmSetTriggerConditionParamInt("PlayerID", i);
      rmSetTriggerConditionParam("Op", "==");
      rmSetTriggerConditionParamInt("Count", 0);

      rmAddTriggerEffect("Flash Units");
      rmSetTriggerEffectParamFloat("Duration", .5, false);
      rmSetTriggerEffectParam("SrcObject", hsid, false);
      rmAddTriggerEffect("Army Deploy");
      rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
      rmSetTriggerEffectParam("ProtoName", name, false);
      rmSetTriggerEffectParamInt("Count", count, false);
      rmSetTriggerEffectParamInt("Heading", 0, false);
      rmSetTriggerEffectParam("Clear", "true", false);
      rmSetTriggerEffectParam("Location", playerSpawnLoc(i), false);
      rmAddTriggerEffect("Army Move");
      rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
      rmSetTriggerEffectParam("DstPoint", playerSpawnMoveLoc(i), false);
      rmSetTriggerEffectParam("AttackMove", "true", false);
      rmAddTriggerEffect("Army Deploy");
      rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
      rmSetTriggerEffectParam("ProtoName", RandomSFX(), false);
      rmSetTriggerEffectParamInt("Count", 1, false);
      rmSetTriggerEffectParamInt("Heading", 0, false);
      rmSetTriggerEffectParam("Clear", "true", false);
      rmSetTriggerEffectParam("Location", playerSpawnLoc(i), false);
      LostGameKillTrig("fav"+favor+"_"+trigname+"_p"+i,i);
   }
}

string addBuyableUnit(string trigname="", string name="", int time=0, int food=0, int wood=0, int gold=0, int favor=0, int maxCount=0, int costmult=1) {
   string uid="";
   for(i=1; <cNumberPlayers) {
      if (name==MythUnit_N) uid=getMythUnit_N(i);
      else if (name==MythUnit_E) uid=getMythUnit_E(i);
      else if (name==MythUnit_G) uid=getMythUnit_G(i);
      else if (name==HeroUnit1) uid=getHeroUnit1(i);
      else if (name==HeroUnit2) uid=getHeroUnit2(i);
      // create the buy trigger
      int id = rmCreateTrigger("buy_"+trigname+"_p"+i);
      rmSwitchToTrigger(id);
      rmSetTriggerLoop(true);
      rmSetTriggerPriority(3);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", time*costmult, false);
      if (maxCount>0) { // LIMIT NUMBER OF UNITS ALLOWED
         rmAddTriggerCondition("Player Unit Count");
         rmSetTriggerConditionParam("ProtoUnit", name);
         rmSetTriggerConditionParamInt("PlayerID", i);
         rmSetTriggerConditionParam("Op", "<=");
         rmSetTriggerConditionParamInt("Count", maxCount);
      }
      rmAddTriggerCondition("Player Resource Count");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("Resource", "favor", false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamInt("Count", favor*costmult, false);
      rmAddTriggerCondition("Player Resource Count");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("Resource", "food", false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamInt("Count", food*costmult, false);
      rmAddTriggerCondition("Player Resource Count");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("Resource", "wood", false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamInt("Count", wood*costmult, false);
      rmAddTriggerCondition("Player Resource Count");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("Resource", "gold", false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamInt("Count", gold*costmult, false);
      rmAddTriggerCondition("Player Population");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("Op", "<", false);
      rmSetTriggerConditionParamInt("Count", (POP_LIMIT+POP_BONUS), false);
      rmAddTriggerCondition("Units In Area");
      rmSetTriggerConditionParamInt("Player", i, false);
      rmSetTriggerConditionParam("DstObject", getBuyPicker(i), false);
      rmSetTriggerConditionParam("UnitType", name, false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamFloat("Dist", 9, false);
      rmSetTriggerConditionParamInt("Count", 1, false);
      rmAddTriggerEffect("Flash Units");
      rmSetTriggerEffectParamFloat("Duration", .5, false);
      rmSetTriggerEffectParam("SrcObject", uid, false);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "favor", false);
      rmSetTriggerEffectParamInt("Amount", 0-(favor*costmult), false);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "food", false);
      rmSetTriggerEffectParamInt("Amount", 0-(food*costmult), false);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "wood", false);
      rmSetTriggerEffectParamInt("Amount", 0-(wood*costmult), false);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "gold", false);
      rmSetTriggerEffectParamInt("Amount", 0-(gold*costmult), false);
      rmAddTriggerEffect("Army Deploy");
      rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
      rmSetTriggerEffectParam("ProtoName", name, false);
      rmSetTriggerEffectParamInt("Count", 1, false);
      rmSetTriggerEffectParamInt("Heading", 0, false);
      rmSetTriggerEffectParam("Clear", "true", false);
      rmSetTriggerEffectParam("Location", playerSpawnLoc(i), false);
      rmAddTriggerEffect("Army Move");
      rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
      rmSetTriggerEffectParam("DstPoint", playerSpawnMoveLoc(i), false);
      rmSetTriggerEffectParam("AttackMove", "true", false);
      rmAddTriggerEffect("Army Deploy");
      rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
      rmSetTriggerEffectParam("ProtoName", RandomSFX(), false);
      rmSetTriggerEffectParamInt("Count", 1, false);
      rmSetTriggerEffectParamInt("Heading", 0, false);
      rmSetTriggerEffectParam("Clear", "true", false);
      rmSetTriggerEffectParam("Location", playerSpawnLoc(i), false);
      LostGameKillTrig("buy_"+trigname+"_p"+i,i);
   }

   string desc=name;
   if (name=="Hero Norse") desc="Hersir";
   else if (name=="Hero Ragnorok") desc="Ragnorok Hero";
   else if (name=="Hero Greek Jason") desc="Jason";
   else if (name=="Hero Greek Odysseus") desc="Odysseus";
   else if (name=="Hero Greek Heracles") desc="Heracles";
   else if (name=="Hero Greek Bellerophon") desc="Bellerophon";
   else if (name=="Hero Greek Ajax") desc="Ajax";
   else if (name=="Hero Greek Chiron") desc="Chiron";
   else if (name=="Hero Greek Achilles") desc="Achilles";
   else if (name=="Hero Greek Perseus") desc="Perseus";
   else if (name=="Hero Greek Theseus") desc="Theseus";
   else if (name=="Hero Greek Hippolyta") desc="Hippolyta";
   else if (name=="Hero Greek Atalanta") desc="Atalanta";
   else if (name=="Hero Greek Polyphemus") desc="Polyphemus";
   else if (name=="Crocodile Of Set") desc="Set Croc";
   else if (name=="Rhinocerous Of Set") desc="Set Rhino";
   else if (name=="Hippo Of Set") desc="Set Hippo";
   else if (name=="Pharaoh Of Osiris") desc="Son Of Osiris";
   return (desc+":"+food+"/"+wood+"/"+gold+"/"+favor+"*");
}

string addBuyableGP(string trigname="", string name="", int cost=0, int cult=0) {
   string hsid="";
   for(i=1; <cNumberPlayers) {
      if (cult==cCultureGreek) hsid=getHotSpot_G(i);
      else if (cult==cCultureNorse) hsid=getHotSpot_N(i);
      else hsid=getHotSpot_E(i);
      int id = rmCreateTrigger("buyGP_"+name+"_p"+i);
      rmSwitchToTrigger(id);
      rmSetTriggerLoop(true);
      rmSetTriggerPriority(3);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 8, false);
      rmAddTriggerCondition("Player Resource Count");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("Resource", "favor", false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamInt("Count", cost, false);
      rmAddTriggerCondition("Units In Area");
      rmSetTriggerConditionParamInt("Player", i, false);
      rmSetTriggerConditionParam("DstObject", hsid, false);
      rmSetTriggerConditionParam("UnitType", BuyPicker, false);
      rmSetTriggerConditionParam("Op", ">=", false);
      rmSetTriggerConditionParamFloat("Dist", 5, false);
      rmSetTriggerConditionParamInt("Count", 1, false);
      rmAddTriggerEffect("Flash Units");
      rmSetTriggerEffectParamFloat("Duration", .5, false);
      rmSetTriggerEffectParam("SrcObject", hsid, false);
      rmAddTriggerEffect("Grant Resources");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParam("ResName", "favor", false);
      rmSetTriggerEffectParamInt("Amount", 0-cost, false);
      rmAddTriggerEffect("Grant God Power");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmSetTriggerEffectParamInt("Count", 1, false);
      rmSetTriggerEffectParam("PowerName", name, false);
      SendChat("Player "+i+" has purchased a "+name+"!");
      rmSetTriggerEffectParamInt("PlayerID", i, false);
      rmAddTriggerEffect("Sound Filename");
      rmSetTriggerEffectParam("Sound", "tributereceived.wav", false);
      LostGameKillTrig("buyGP_"+trigname+"_p"+i,i);
   }
   string desc=name;
   if (desc=="Underworld Passage") desc="Hades Passage";
   else if (desc=="Lightning Storm") desc="Lightn Storm";
   else if (desc=="SandStorm") desc="Shiftn Sand";
   else if (desc=="Flaming Weapons") desc="Flame Weapon";
   else if (desc=="Walking Woods") desc="Walkn Woods";
   else if (desc=="Skeleton Power") desc="Ancestors";
   return (desc);
}

string PickNorseHero(int buy=0, string pick="") {
   string buystring="";
   if (buy==0) return(chooseRandString("Hero Norse","Hero Ragnorok","Ornlu")); //,"Reginleif"
   if (pick=="Hero Norse")         buystring=addBuyableUnit("nhero",pick, 5, 4, 0, 2, 5);
   else if (pick=="Hero Ragnorok") buystring=addBuyableUnit("nhero",pick, 3, 3, 3, 3, 3);
   else if (pick=="Brokk")         buystring=addBuyableUnit("nhero",pick, 3, 0, 0,10, 3);
   else if (pick=="Eitri")         buystring=addBuyableUnit("nhero",pick, 3, 0, 0,10, 3);
   else if (pick=="Ornlu")         buystring=addBuyableUnit("nhero",pick, 5,18, 0, 0, 3);
   return(buystring);
}

string PickEgyptHero(int buy=0, string pick="") {
   string buystring="";
   if (buy==0) {
      if (rmRandInt(1,10)==1) return("Pharaoh Of Osiris"); // KEEP IT RARE
      return(chooseRandString("Priest","Pharaoh")); // "Setna","Shaba ka","Theris","Amanra"
   }
   if     (pick=="Priest")             buystring=addBuyableUnit("ehero",pick, 2, 0, 0, 5, 1);
   else if (pick=="Pharaoh")           buystring=addBuyableUnit("ehero",pick, 2, 4, 0, 2, 2);
   else if (pick=="Pharaoh of Osiris") buystring=addBuyableUnit("ehero",pick,15,90,90,90,45,3);
   return(buystring);
}

string PickGreekHero(int buy=0, string pick="", int civ=-1) {
   string buystring="";
   if (buy==0) {
      int i=iifF(civ==-1,rmRandInt(0,2),civ);
      if (i==cCivZeus) return(chooseRandString("Hero Greek Jason","Hero Greek Odysseus","Hero Greek Heracles","Hero Greek Bellerophon","Circe"));
      else if (i==cCivPoseidon) return(chooseRandString("Hero Greek Theseus","Hero Greek Hippolyta","Hero Greek Atalanta","Hero Greek Polyphemus")); //,"Arkantos"
      else if (i==cCivHades) return(chooseRandString("Hero Greek Ajax","Hero Greek Chiron",,"Hero Greek Perseus","Hero Greek Achilles","Gargarensis")); //"Ajax",
   }
   if      (pick=="Hero Greek Ajax")        buystring=addBuyableUnit("ghero",pick, 2, 5, 0, 2, 1);
   else if (pick=="Hero Greek Jason")       buystring=addBuyableUnit("ghero",pick, 2, 6, 0, 2, 1);
   else if (pick=="Hero Greek Theseus")     buystring=addBuyableUnit("ghero",pick, 2, 5, 0, 2, 1);

   else if (pick=="Hero Greek Chiron")      buystring=addBuyableUnit("ghero",pick, 3, 0,10, 0, 2);
   else if (pick=="Hero Greek Hippolyta")   buystring=addBuyableUnit("ghero",pick, 3, 0,10, 0, 2);
   else if (pick=="Hero Greek Odysseus")    buystring=addBuyableUnit("ghero",pick, 3, 0,10, 0, 2);

   else if (pick=="Hero Greek Achilles")    buystring=addBuyableUnit("ghero",pick, 5,18, 0, 0, 3);
   else if (pick=="Hero Greek Atalanta")    buystring=addBuyableUnit("ghero",pick, 5, 0,18, 0, 3);
   else if (pick=="Hero Greek Heracles")    buystring=addBuyableUnit("ghero",pick, 5,18, 0, 0, 3);

   else if (pick=="Hero Greek Bellerophon") buystring=addBuyableUnit("ghero",pick, 5, 0, 0,20, 5);
   else if (pick=="Hero Greek Perseus")     buystring=addBuyableUnit("ghero",pick, 5, 0, 0,20, 5);
   else if (pick=="Hero Greek Polyphemus")  buystring=addBuyableUnit("ghero",pick, 5, 0, 0,20, 5);

   else if (pick=="Circe")                  buystring=addBuyableUnit("ghero",pick,10,50,50,50,25);
   else if (pick=="Gargarensis")            buystring=addBuyableUnit("ghero",pick,10,20,20,20,9);
   return(buystring);
}

string PickNorseMyth(int buy=0, string pick="", int age=0) {
   string buystring="";
   if (buy==0) {
      int i=iifF(age==0,rmRandInt(1,3),age);
      if (i==1) return(chooseRandString("Einheriar","Troll","Valkyrie"));
      else if (i==2) return(chooseRandString("Battle Boar","Mountain Giant","Frost Giant"));
      else return(chooseRandString("Fenris Wolf","Fire Giant"));
   }
   if      (pick=="Einheriar")        buystring=addBuyableUnit("nmyth",pick, 3, 0, 0, 9, 2);
   else if (pick=="Troll")            buystring=addBuyableUnit("nmyth",pick, 3, 0, 8, 0, 2);
   else if (pick=="Valkyrie")         buystring=addBuyableUnit("nmyth",pick, 3,10, 0, 0, 2);
   else if (pick=="Battle Boar")      buystring=addBuyableUnit("nmyth",pick, 4, 0, 0,12, 3);
   else if (pick=="Frost Giant")      buystring=addBuyableUnit("nmyth",pick, 4, 0, 0,10, 2);
   else if (pick=="Mountain Giant")   buystring=addBuyableUnit("nmyth",pick, 3,15, 0, 0, 3,8,2); // BUILDING KILLER SET MAX & DOUBLE COST
   else if (pick=="Fenris Wolf")      buystring=addBuyableUnit("nmyth",pick, 3, 0, 0, 8, 2);
   else if (pick=="Fire Giant")       buystring=addBuyableUnit("nmyth",pick, 5, 0, 0,15, 4,8,2); // BUILDING KILLER SET MAX & DOUBLE COST
   return(buystring);
}

string PickEgyptMyth(int buy=0, string pick="", int age=0) {
   string buystring="";
   if (buy==0) {
      int i=iifF(age==0,rmRandInt(1,3),age);
      if (i==1) return(chooseRandString("Wadjet","Anubite","Sphinx",chooseRandString("Crocodile","Ape")+" Of Set"));
      else if (i==2) return(chooseRandString("Scorpion Man","Petsuchos","Scarab"));
      else return(chooseRandString("Avenger","Mummy",chooseRandString("Rhinoceros","Hippo")+" Of Set"));
   }
   if      (pick=="Ape of Set")       buystring=addBuyableUnit("emyth",pick, 2, 2, 0, 0, 1);
   else if (pick=="Anubite")          buystring=addBuyableUnit("emyth",pick, 2, 5, 0, 0, 2);
   else if (pick=="Sphinx")           buystring=addBuyableUnit("emyth",pick, 3, 6, 0, 0, 2);
   else if (pick=="Wadjet")           buystring=addBuyableUnit("emyth",pick, 3, 0, 8, 0, 2);
   else if (pick=="Crocodile Of Set") buystring=addBuyableUnit("emyth",pick, 5, 8, 0, 0, 2);
   else if (pick=="Petsuchos")        buystring=addBuyableUnit("emyth",pick, 4, 0, 0,10, 2);
   else if (pick=="Scarab")           buystring=addBuyableUnit("emyth",pick, 4,15, 0, 0, 2,8,3); // BUILDING KILLER SET MAX & DOUBLE COST
   else if (pick=="Scorpion Man")     buystring=addBuyableUnit("emyth",pick, 4, 0, 8, 0, 2);
   else if (pick=="Avenger")          buystring=addBuyableUnit("emyth",pick, 5,12, 0, 0, 3);
   else if (pick=="Hippo Of Set")     buystring=addBuyableUnit("emyth",pick, 3,12, 0, 0, 2);
   else if (pick=="Mummy")            buystring=addBuyableUnit("emyth",pick, 3, 0, 0,10, 4);
   else if (pick=="Rhinoceros Of Set")buystring=addBuyableUnit("emyth",pick, 4,15, 0, 0, 2);
   return(buystring);
}

string PickGreekMyth(int buy=0, string pick="", int age=0) {
   string buystring="";
   if (buy==0) {
      int i=iifF(age==0,rmRandInt(1,3),age);
      if (i==1) return(chooseRandString("Centaur","Cyclops","Minotaur","Shade Of Erebus"));
      else if (i==2) return(chooseRandString("Manticore","Nemean Lion","Hydra"));
      else return(chooseRandString("Colossus","Medusa","Chimera"));
   }
   if      (pick=="Centaur")          buystring=addBuyableUnit("gmyth",pick, 4, 0,10, 0, 2);
   else if (pick=="Cyclops")          buystring=addBuyableUnit("gmyth",pick, 4,12, 0, 0, 2);
   else if (pick=="Minotaur")         buystring=addBuyableUnit("gmyth",pick, 4,10, 0, 0, 2);
   else if (pick=="Hydra")            buystring=addBuyableUnit("gmyth",pick, 4,12, 0, 0, 3);
   else if (pick=="Manticore")        buystring=addBuyableUnit("gmyth",pick, 3, 0,15, 0, 3);
   else if (pick=="Nemean Lion")      buystring=addBuyableUnit("gmyth",pick, 4, 0, 0,12, 2);
   else if (pick=="Chimera")          buystring=addBuyableUnit("gmyth",pick, 4, 0, 0,15, 3);
   else if (pick=="Colossus")         buystring=addBuyableUnit("gmyth",pick, 5, 0, 0,15, 4,8,2); // BUILDING KILLER SET MAX & DOUBLE COST
   else if (pick=="Shade Of Erebus")  buystring=addBuyableUnit("gmyth",pick, 2, 0, 3, 0, 1);
   else if (pick=="Medusa")           buystring=addBuyableUnit("gmyth",pick, 4, 0, 0,12, 4);
   return(buystring);
}

string PickNorseGodPower() {
   string pick=chooseRandString("Undermine","Frost","Walking Woods","Flaming Weapons");
   int cost=0;
   int time=0;
   if (pick=="Undermine") cost=25;
   else if (pick=="Frost") cost=35;
   else if (pick=="Walking Woods") cost=35;
   else if (pick=="Flaming Weapons") cost=35;
   pick=addBuyableGP("norse",pick,cost,cCultureNorse);
   return("*Norse*"+pick+"("+cost+")");
}

string PickEgyptGodPower() {
   string pick=chooseRandString("Sandstorm","Meteor","Skeleton Power","Serpents"); //"Prosperity",
   if (rmRandInt(1,10)==1) pick="Tornado"; // VERY POWERFUL, MAKE IT APPEAR LESS OFTEN
   if (rmRandInt(1,13)==1) pick="Eclipse"; // NOT THAT GREAT, MAKE IT APPEAR LESS OFTEN
   int cost=0;
   if (pick=="Eclipse") cost=50;
   else if (pick=="SandStorm") { cost=20; GotTransportGP="";}
   else if (pick=="Meteor") cost=55;
   else if (pick=="Tornado") cost=65;
   else if (pick=="Skeleton Power") cost=30;
   else if (pick=="Serpents") cost=30;
   pick=addBuyableGP("egypt",pick,cost,cCultureEgyptian);
   return("*Egypt*"+pick+"("+cost+")");
}

string PickGreekGodPower() {
   // GotTransportGP will be blank if SandStorm was selected as Eggie GP
   string pick=chooseRandString("Bronze","Lightning Storm",GotTransportGP);
   int cost=0;
   if (pick=="Curse") cost=20;
   else if (pick=="Bronze") cost=35;
   else if (pick=="Underworld Passage") cost=65;
   else if (pick=="Lightning Storm") cost=55;
   pick=addBuyableGP("greek",pick,cost,cCultureGreek);
   return("*Greek*"+pick+"("+cost+")");
}

void SetTechStatus(int i=1, int tech=0, int OnOff=0) {
    rmAddTriggerEffect("Set Tech Status");
    rmSetTriggerEffectParamInt("PlayerID", i, false);
    rmSetTriggerEffectParamInt("TechID", tech, false);
    rmSetTriggerEffectParamInt("Status", OnOff, false);
}

void addTechAvailFreeUnit(string name="", int i=0) {
   rmAddTriggerEffect("Army Deploy");
   rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
   rmSetTriggerEffectParam("ProtoName", name, false);
   rmSetTriggerEffectParamInt("Count", 1, false);
   rmSetTriggerEffectParamInt("Heading", 0, false);
   rmSetTriggerEffectParam("Clear", "true", false);
   rmSetTriggerEffectParam("Location", playerGiftLoc(i), false);
   rmAddTriggerEffect("Army Deploy");
   rmSetTriggerEffectParamArmy("SrcArmy", i, getArmy(i), false);
   rmSetTriggerEffectParam("ProtoName", RandomSFX(), false);
   rmSetTriggerEffectParamInt("Count", 1, false);
   rmSetTriggerEffectParamInt("Heading", 0, false);
   rmSetTriggerEffectParam("Clear", "true", false);
   rmSetTriggerEffectParam("Location", playerGiftLoc(i), false);
}

void addTechAvailMuliplier(int tech=0,string desc="",int type=0, int mult=2) {
   for(i=1; <cNumberPlayers) {
      // create the AgeUp trigger
      int id = rmCreateTrigger("TechMultiplier_"+tech+"_p"+i);
      rmSwitchToTrigger(id);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(3);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 2, false);
      rmAddTriggerCondition("Tech Available");
      rmSetTriggerConditionParamInt("PlayerID", i, false);
      rmSetTriggerConditionParam("TechID", ""+tech, false);
      for(j=1; <=mult) SetTechStatus(i, tech, cTechStatusActive);
      if (desc!="") {
         SendChat("Player "+i+" has researched "+desc+".");
         rmAddTriggerEffect("Sound Filename");
         if (type==1) rmSetTriggerEffectParam("Sound", "armory.wav", false);
         else if (type==2) rmSetTriggerEffectParam("Sound", "herorevived.wav", false);
         else if (type==3) rmSetTriggerEffectParam("Sound", "villagercreate.wav", false);
      }
      if (tech==cTechFortifyTownCenter) {
         rmAddTriggerEffect("Grant God Power");
         rmSetTriggerEffectParamInt("PlayerID", i, false);
         rmSetTriggerEffectParamInt("Count", 1, false);
         rmSetTriggerEffectParam("PowerName", "Sentinel", false);
      } else if (tech==cTechHandAxe || tech==cTechPickaxe || tech==cTechPlow) {
         addTechAvailFreeUnit("Villager Egyptian",i);
      }
   }
}

void AddPlentyVault(int i=0,float MyAtX=0, float MyAtZ=0) {
   int id=rmCreateObjectDef("vault"+i);
   rmAddObjectDefItem(id, "plenty vault KOTH", 1, 0.0);
   rmSetObjectDefMinDistance(id, 0.0);
   rmSetObjectDefMaxDistance(id, 0.0);
   rmPlaceObjectDefAtLoc(id, 0, MyAtX, MyAtZ);
   int oid=rmGetUnitPlaced(id,0);
   int aid=rmCreateArmy(0, "vault"+i);
   rmAddUnitsToArmy(0, aid, id);
   id = rmCreateTrigger("ConvertPVToGaia_"+i);
   rmSwitchToTrigger(id);
   rmSetTriggerLoop(true);
   rmSetTriggerPriority(3);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 30, false);
   rmAddTriggerCondition("Units In Area");
   rmSetTriggerConditionParam("DstObject", ""+oid, false);
   rmSetTriggerConditionParam("UnitType", "Military", false);
   rmSetTriggerConditionParam("Op", ">", false);
   rmSetTriggerConditionParamFloat("Dist", 10, false);
   rmSetTriggerConditionParamInt("Count", 1, false);
   rmAddTriggerEffect("Army Convert");
   rmSetTriggerEffectParamArmy("SrcArmy",0, aid);
   rmSetTriggerEffectParamInt("PlayerID", 0);
}

string GetAnimalType(int HerdHuntFatten=0) {
   // RANDOMLY SELECT AN ANIMAL BASED ON MapSkin
   int MapSkin=MapSkin;
   int rand=0;
   if (HerdHuntFatten==1) { // LOOKING FOR HERDABLE TYPE - STATIC
      rand = rmRandInt(1,2);
      if (rand==1) return("Berry Bush");
      else if (rand==2) return("Chicken");
   } else if (HerdHuntFatten==2) { // LOOKING FOR HUNTABLE
      if (MapSkin==1 || MapSkin==4) {// WINTER/FALL HUNTABLE
         rand = rmRandInt(1,4);
         if (rand==1) return("Caribou");
         else if (rand==2) return("Deer");
         else if (rand==3) return("Boar");
         else if (rand==4) return("Elk");
      }
      if (MapSkin==2) {// SPRING HUNTS
         rand = rmRandInt(1,4);
         if (rand==1) return("Gazelle");
         else if (rand==2) return("Hippo");
         else if (rand==3) return("Crowned Crane");
         else if (rand==4) return("Monkey");
         else if (rand==5) return("Elephant");
         else if (rand==6) return("Rhinocerous");
         else if (rand==7) return("Giraffe");
      }
      if (MapSkin==3) {// SUMMER HUNTS
         rand = rmRandInt(1,4);
         if (rand==1) return("Crowned Crane");
         else if (rand==2) return("Deer");
         else if (rand==3) return("Boar");
         else if (rand==4) return("Aurochs");
      }
      if (MapSkin==5) {// MORDOR HUNTABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Baboon");
         else if (rand==2) return("Boar");
         else if (rand==3) return("Rhinocerous");
      }
   } else if (HerdHuntFatten==3) { // LOOKING FOR FATTENABLE TYPES
      rand = rmRandInt(1,2);
      if (rand==1) return("goat");
      else if (rand==2) return("pig");
      else if (rand==3) return("cow");
   }
}

float GetAnimalCount(string Animal="") {
   if (Animal=="Aurochs") return (5); //(400.0));
   if (Animal=="Baboon") return (15); //(80.0));
   if (Animal=="Berry Bush") return (24); //(100.0));
   if (Animal=="Boar") return (8); //(300.0));
   if (Animal=="Caribou") return (12); //(150.0));
   if (Animal=="Chicken") return (24); //(75.0));
   if (Animal=="Cow") return (10); //(75.0));
   if (Animal=="Crowned Crane") return (15); //(100.0));
   if (Animal=="Deer") return (15); //(150.0));
   if (Animal=="Elephant") return (3); //(750.0));
   if (Animal=="Elk") return (12); //(150.0));
   if (Animal=="Gazelle") return (12); //(100.0));
   if (Animal=="Giraffe") return (5); //(300.0));
   if (Animal=="Goat") return (12); //(50.0));
   if (Animal=="Hippo") return (4); //(400.0));
   if (Animal=="Monkey") return (15); //(100.0));
   if (Animal=="Pig") return (12); //(50.0));
   if (Animal=="Rhinocerous") return (4); //(500.0));
   if (Animal=="Zebra") return (10); //(200.0));
}

string GetSeaType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("North Atlantic Ocean"); // WINTER
   else if (ThisSkin==2) return("Red Sea"); // SPRING
   else if (ThisSkin==3) return("Aegean Sea"); // SPRING
   else if (ThisSkin==4) return("Norwegian Sea");// FALL
   else if (ThisSkin==5) return("Styx River"); // MORDOR
}

string GetLandType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("CliffNorseB"); // WINTER
   else if (ThisSkin==2) return("SavannahA"); // SPRING
   else if (ThisSkin==3) return("GrassA"); // SUMMER
   else if (ThisSkin==4) return("SnowGrass75"); // FALL
   else if (ThisSkin==5) return("ForestFloorDeadPine"); // MORDOR
}

string GetTreeType(int ForestOrTreeType=0) {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ForestOrTreeType==1) { // LOOKING FOR A FOREST TYPE
      if (ThisSkin==1) { // WINTER
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Snow Pine Forest");
         else if (ThisSkin==2) return("Mixed Pine Forest");
      }
      else if (ThisSkin==2) return("Savannah Forest"); // SPRING
      else if (ThisSkin==3) { // SUMMER
         ThisSkin=rmRandInt(1,4);
         if (ThisSkin==1) return("Mixed Oak Forest");
         else if (ThisSkin==2) return("Pine Forest");
         else if (ThisSkin==3) return("Oak Forest");
         else if (ThisSkin==4) return("Palm Forest");
      }
      else if (ThisSkin==4) { // FALL
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Autumn Oak Forest");
         else if (ThisSkin==2) return("Pine Forest");
      }
      else if (ThisSkin==5) return("Hades Forest"); // MORDOR
   } else { // INDIVIDUAL TREE
      if (ThisSkin==1) return("Pine Snow"); // WINTER
      else if (ThisSkin==2) return("Savannah Tree"); // SPRING
      else if (ThisSkin==3) {
         ThisSkin=rmRandInt(1,3);
         if (ThisSkin==1) return("Oak Tree");
         else if (ThisSkin==2) return("Pine");
         else if (ThisSkin==3) return("Palm");
      }
      else if (ThisSkin==4) {
         ThisSkin=rmRandInt(1,2); // FALL
         if (ThisSkin==1) return("Oak Autumn");
         else if (ThisSkin==2) return("Pine");
      }
      else if (ThisSkin==5) return("Pine Dead"); // MORDOR
   }
}

string GetBlackType() {
   if (MapSkin==1) return("Hades6"); // WINTER
   else if (MapSkin==2) return("Hades6"); // SPRING
   else if (MapSkin==3) return("HadesCliff"); // SUMMER
   else if (MapSkin==4) return("HadesCliff"); // FALL
   else if (MapSkin==5) return("Hades3"); // MORDOR
}

string GetBlackType2() {
   if (MapSkin==1) return("CliffNorseA"); // WINTER
   else if (MapSkin==2) return("CliffEgyptianA"); // SPRING
   else if (MapSkin==3) return("CliffGreekA"); // SUMMER
   else if (MapSkin==4) return("CliffNorseB"); // FALL
   else if (MapSkin==5) return("HadesCliff"); // MORDOR
}

string GetRoadType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("NorseRoadA"); // WINTER
   else if (ThisSkin==2) return("GreekRoadA"); // SPRING
   else if (ThisSkin==3) { // SUMMER
      if (rmRandInt(2,2)==1) return("CityTileA");
      return("CityTileAtlantis");
   }
   else if (ThisSkin==4) return("NorseRoadA"); // FALL
   else if (ThisSkin==5) return("UnderWaterRockC"); // MORDOR
}

void LayerTerrain(int id=0, float Width=6) {
   // WIDTH IN METERS!! - Layers starting at 0 go from outer edge toward area center
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) { // WINTER
      rmAddAreaTerrainLayer(id,"SnowA",0, Width * .33);
      rmAddAreaTerrainLayer(id,"SnowGrass50",Width * .33,Width * .66);
      rmAddAreaTerrainLayer(id,"SnowGrass25",Width * .66,Width);
   } else if (ThisSkin==2) { // SPRING
      rmAddAreaTerrainLayer(id,"SavannahC",0, Width * .25);
      rmAddAreaTerrainLayer(id,"SavannahD", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SavannahC", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"SavannahB", Width * .75,Width);
   } else if (ThisSkin==3) { // SUMMER
      rmAddAreaTerrainLayer(id,"GrassDirt25",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffGreekB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"GrassDirt50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"GrassDirt25", Width * .75,Width);
   } else if (ThisSkin==4) { // FALL
      rmAddAreaTerrainLayer(id,"SnowGrass75",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SnowGrass50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .75,Width);
   } else if (ThisSkin==5) { // MORDOR
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",0,Width * .5);
      rmAddAreaTerrainLayer(id,"HadesBuildable2",Width * .5,Width);
   }
}

void SetMainLandType(int id=0, int LayerWidth=0, int Height=2, string ForceType="") {
   if (ForceType=="") {
      rmSetAreaTerrainType(id,GetLandType());
      LayerTerrain(id, LayerWidth);
   } else {
      rmSetAreaTerrainType(id,ForceType);
   }
   rmSetAreaSmoothDistance(id,6);
   rmSetAreaBaseHeight(id,Height);
}

void SetMainWaterType(int id=0) {
   rmSetAreaWaterType(id, GetSeaType());
}

/* AREA FUNCTIONS  ************************************/
int CreateAreaAtXZ(string ObjName="", float AtX=.5, float AtZ=.5, float WidthX=0, float HeightBlend=2, float Coherence=1, int ParentArea=-1) {
   int id = 0;
   if (ParentArea>-1) {
      id = rmCreateArea(ObjName, ParentArea);
   } else id = rmCreateArea(ObjName);
   rmSetAreaHeightBlend(id,HeightBlend);
   if (AtX>-1 && AtZ>-1) rmSetAreaLocation(id,AtX,AtZ);
   rmSetAreaSize(id,WidthX,WidthX);
   rmSetAreaCoherence(id,Coherence);
   return (id);
}

int MakeBase(int i=0, string ObjName="", int ThisAngle=0, float Dist=0, string Unit="", string Terrain="") {
   float MyAtX=GetXPointOnCircle(ThisAngle, Dist, .5);
   float MyAtZ=GetZPointOnCircle(ThisAngle, Dist, .5);
   int id=CreateAreaAtXZ(ObjName+"x_"+i, MyAtX, MyAtZ, rmXMetersToFraction(.06), 0.0, 1);
   if (Terrain=="") rmSetAreaTerrainType(id,"Black");
   else rmSetAreaTerrainType(id,Terrain);
   rmBuildArea(id);
   if (Unit!="") {
      id=rmCreateObjectDef(ObjName+"Unit_p"+i);
      rmAddObjectDefItem(id, Unit, 1, 0);
      rmSetObjectDefMinDistance(id,0);
      rmSetObjectDefMaxDistance(id,0);
      rmPlaceObjectDefAtLoc(id, i, MyAtX, MyAtZ, 1);
      id=rmGetUnitPlaced(id,0);
   }
   return(id);
}

void PlaceRelic(int i=0, int TechID=0) {
   int rid=rmCreateObjectDef("Relic"+TechID+"_"+i);
   rmAddObjectDefItem(rid, "relic", 1, 0);
   rmSetObjectDefMinDistance(rid,25);
   rmSetObjectDefMaxDistance(rid,rmZFractionToMeters(.22));
   rmAddObjectDefConstraint(rid, avoidRelicLong);
   rmPlaceObjectDefAtLoc(rid, 0, .5, .5, 1);
   rid=rmGetUnitPlaced(rid,0);
   int id = rmCreateTrigger("RelicForce"+TechID+"_"+i);
   rmSwitchToTrigger(id);
   rmSetTriggerLoop(false);
   rmSetTriggerPriority(3);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 1, false);
   rmAddTriggerEffect("Relic Force");
   rmSetTriggerEffectParam("SrcObject", ""+rid, false);
   rmSetTriggerEffectParam("TechID", ""+TechID, false);
}

void main(void) {

   // **SETUP THIS TRIGGER NOW SO THINGS CAN BE ADDED AS WE GO ALONG
   int id = rmCreateTrigger("RunASAP");
   rmSwitchToTrigger(id);
   rmSetTriggerPriority(4);
   for(i=1; <cNumberPlayers) {
      // AGE EM UP
      SetTechStatus(i, cTechAge2Heimdall, cTechStatusActive);
      SetTechStatus(i, cTechAge3Njord, cTechStatusActive);
      SetTechStatus(i, cTechAge4Baldr, cTechStatusActive);
      rmAddTriggerEffect("Player Kill All God Powers");
      rmSetTriggerEffectParamInt("Player", i, false);
      SetTechStatus(i, cTechStartingUnitsNorse, cTechStatusUnobtainable);
      SetTechStatus(i, cTechStartingUnitsThor, cTechStatusUnobtainable);
   }

   // ** CONSTANTS ************************************
   // set size
   int myTiles=1200;
   int sizeX=600;
   int sizeZ=600;
   rmEchoInfo("Map size="+sizeX+"m x "+sizeZ+"m");
   rmSetMapSize(sizeX, sizeZ);

   MapSkin = rmRandInt(1,50);  // I don't like hades,so only do it rarely
   if (MapSkin>5) MapSkin = rmRandInt(1,4);
   MapSkin=3;
   SeaOrLand=rmRandInt(0,1);
   SeaOrLand=0;
   float pct=1.0;
   rmSetStatusText("",pct);
   pct = pct-0.05;
   float MyAtX=0;
   float MyAtZ=0;

   rmSetSeaLevel(SeaLevel);
   rmSetSeaType(GetSeaType());
   if (SeaOrLand==0) rmTerrainInitialize(GetBlackType());
   else {
      rmTerrainInitialize("water");
   }

   avoidBuildingsLong=rmCreateTypeDistanceConstraint("Avoid Buildings Long", "Building", avoidBuildingsLong);
   avoidGoldLong=rmCreateTypeDistanceConstraint("avoid Gold Long", "gold", avoidGoldLong);
   avoidRelicLong=rmCreateTypeDistanceConstraint("avoid Relics Long", "relic", avoidRelicLong);

   rmSetStatusText("",pct);
   pct = pct-0.05;
   myNumPlayers=cNumberNonGaiaPlayers;
//   myNumPlayers=12;

   int Scaler=myNumPlayers/2;
   float MainLandSize=12-myNumPlayers;
   MainLandSize=.15-(MainLandSize * 0.0115);
   // MAIN LAND
   int cid = CreateAreaAtXZ("center", .5, .5, MainLandSize, 2.0, 1);
   SetMainLandType(cid, 20, SeaLevel+2.0);
   rmBuildAllAreas();

   for(i=0; <rmRandInt(myNumPlayers,myNumPlayers*2)) {
      id = CreateAreaAtXZ("patches"+i, -1, -1, rmAreaTilesToFraction(rmRandInt(300,500)), 2.0, 0, cid);
      SetMainLandType(id, 6, SeaLevel+rmRandInt(-4,6));
      rmBuildArea(id);
   }

   rmSetStatusText("",pct);
   pct = pct-0.05;

   int PlayerAngle=360/myNumPlayers;
   float PlayerDist=0.47;
   float PlayerSize=rmAreaTilesToFraction(600);
   float MyInfX=0;
   float MyInfZ=0;
   float MyInf2X=0;
   float MyInf2Z=0;
   int ThisAngle=0;
   float moveout=1.15;
   KillLoc=.07 + .01 * myNumPlayers;
   KillLoc=12-myNumPlayers;
   KillLoc=.215-(KillLoc  * 0.0114);

   MythUnit_N=PickNorseMyth();
   int whichhero1 = rmRandInt(1,3);
   int whichhero2 = 0;
   if (whichhero1==1) {
      HeroUnit1=PickNorseHero();
      HeroUnit2=PickEgyptHero();
      whichhero2=2;
   } else if (whichhero1==2) {
      HeroUnit1=PickEgyptHero();
      HeroUnit2=PickGreekHero();
      whichhero2=3;
   } else {
      HeroUnit1=PickNorseHero();
      HeroUnit2=PickGreekHero();
      whichhero1=1;
      whichhero2=3;
   }
   MythUnit_E=PickEgyptMyth();
   MythUnit_G=PickGreekMyth();
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // ASSIGN PLAYER SLOTS BY TEAM
   int ThisSlot=1;
   for (i=0;<cNumberTeams) {
      for (j=1; <cNumberPlayers) {
         if (rmGetPlayerTeam(j)==i) {
            setSlot(j,ThisSlot);
            ThisSlot++;
         }
      }
   }

   // PLAYER BASES
   for(i=1; <cNumberPlayers) {
      ThisSlot=getSlot(i);
      rmSetStatusText("",pct);
      pct = pct-0.09;
      setArmy(i, rmCreateArmy(i, "army"+ThisSlot));
      ThisAngle=(PlayerAngle * (ThisSlot-1));
      MyAtX=GetXPointOnCircle(ThisAngle, PlayerDist, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, PlayerDist, .5);
      MyInfX=GetXPointOnCircle(ThisAngle-5, PlayerDist, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-5, PlayerDist, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle+5, PlayerDist, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle+5, PlayerDist, .5);
      id = CreateAreaAtXZ("SafeBase"+i, MyAtX, MyAtZ, PlayerSize, 2.0, 1);
      rmSetAreaTerrainType(id,GetLandType());
      LayerTerrain(id, 8);
      rmAddAreaInfluenceSegment(id, MyInf2X, MyInf2Z, MyInfX, MyInfZ);
      rmBuildArea(id);
      rmPlacePlayer(i,MyAtX,MyAtZ);
      rmSetPlayerArea(i, id);

      id = CreateAreaAtXZ("RightEye"+i, MyInfX, MyInfZ, rmXMetersToFraction(.95), 2.0, 1);
      SetMainLandType(id, 6, SeaLevel,"UnderWaterRockA");
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",0, .75);
      id = CreateAreaAtXZ("LeftEye"+i, MyInf2X, MyInf2Z, rmXMetersToFraction(.95), 2.0, 1);
      SetMainLandType(id, 6, SeaLevel,"UnderWaterRockA");
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",0, .25);
      rmBuildAllAreas();

      moveout=0.499;
      MyAtX=GetXPointOnCircle(ThisAngle, moveout, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, moveout, .5);
      MyInfX=GetXPointOnCircle(ThisAngle-5, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-5, moveout, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle+5, moveout, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle+5, moveout, .5);
      id = CreateAreaAtXZ("TreeLine"+i, MyAtX, MyAtZ, rmXMetersToFraction(1), 2.0, 1);
      rmSetAreaForestType(id,GetTreeType(1));
      rmAddAreaInfluenceSegment(id, MyInf2X, MyInf2Z, MyInfX, MyInfZ);
      rmBuildArea(id);

      moveout=.384;
      MakeBase(i, "CivPathN_2_", ThisAngle-4, moveout,"",GetRoadType());
      MakeBase(i, "CivPathE_2_", ThisAngle-0, moveout,"",GetRoadType());
      MakeBase(i, "CivPathG_2_", ThisAngle+4, moveout,"",GetRoadType());
      moveout=.39;
      MakeBase(i, "CivPathN_1_", ThisAngle-4, moveout,"",GetRoadType());
      MakeBase(i, "CivPathE_1_", ThisAngle-0, moveout,"",GetRoadType());
      MakeBase(i, "CivPathG_1_", ThisAngle+4, moveout,"",GetRoadType());

      moveout=.405;
      MyAtX=GetXPointOnCircle(ThisAngle, moveout, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, moveout, .5);
      MyInfX=GetXPointOnCircle(ThisAngle-6, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-6, moveout, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle+6, moveout, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle+6, moveout, .5);
      id = CreateAreaAtXZ("Center1_"+i, MyAtX, MyAtZ, rmXMetersToFraction(1), 2.0, 1);
      rmSetAreaTerrainType(id,GetRoadType());
      rmSetAreaSmoothDistance(id,0);
      rmAddAreaInfluenceSegment(id, MyInf2X, MyInf2Z, MyInfX, MyInfZ);
      rmBuildArea(id);

      moveout=.4166;
      MakeBase(i, "UnitPath1_1_", ThisAngle-6, moveout,"",GetRoadType());
      MakeBase(i, "UnitPath2_1_", ThisAngle-3, moveout,"",GetRoadType());
      MakeBase(i, "UnitPath3_1_", ThisAngle-0, moveout,"",GetRoadType());
      MakeBase(i, "UnitPath4_1_", ThisAngle+3, moveout,"",GetRoadType());
      MakeBase(i, "UnitPath5_1_", ThisAngle+6, moveout,"",GetRoadType());
      moveout=.431;
      id=MakeBase(i, "UnitPath1_2_", ThisAngle-6, moveout,MythUnit_N,GetRoadType());
      setMythUnit_N(i,""+id);
      id=MakeBase(i, "UnitPath2_2_", ThisAngle-3, moveout,HeroUnit1,GetRoadType());
      setHeroUnit1(i,""+id);
      id=MakeBase(i, "UnitPath3_2_", ThisAngle-0, moveout,MythUnit_E,GetRoadType());
      setMythUnit_E(i,""+id);
      id=MakeBase(i, "UnitPath4_2_", ThisAngle+3, moveout,HeroUnit2,GetRoadType());
      setHeroUnit2(i,""+id);
      id=MakeBase(i, "UnitPath5_2_", ThisAngle+6, moveout,MythUnit_G,GetRoadType());
      setMythUnit_G(i,""+id);

      MyAtX=GetXPointOnCircle(ThisAngle, KillLoc+.07, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, KillLoc+.07, .5);
      MyInfX=GetXPointOnCircle(ThisAngle, KillLoc, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle, KillLoc, .5);
      id = CreateAreaAtXZ("KillBase"+i, MyAtX, MyAtZ, PlayerSize, 2.0, 1);
      rmAddAreaInfluenceSegment(id, MyAtX, MyAtZ, MyInfX, MyInfZ);
      SetMainLandType(id, 6, SeaLevel+2.0);
      rmBuildArea(id);

      MyAtX=GetXPointOnCircle(ThisAngle, KillLoc+.03, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, KillLoc+.03, .5);
      id = CreateAreaAtXZ("OpenBase"+i, MyAtX, MyAtZ, PlayerSize*.9, 2.0, 1);
      SetMainLandType(id, 6, SeaLevel+2.0);
      rmBuildArea(id);

      MyAtX=GetXPointOnCircle(ThisAngle, KillLoc+.05, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, KillLoc+.05, .5);
      MyInfX=GetXPointOnCircle(ThisAngle, KillLoc-0.02, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle, KillLoc-0.02, .5);
      id = CreateAreaAtXZ("RoadBase"+i, MyAtX, MyAtZ, rmZMetersToFraction(1), 2.0, 1);
      rmAddAreaInfluenceSegment(id, MyAtX, MyAtZ, MyInfX, MyInfZ);
      SetMainLandType(id, 6, SeaLevel+2.0,GetRoadType());
      rmBuildArea(id);

      rmEchoInfo("Built areas for player "+i+" @ "+MyAtX+","+MyAtZ);
   }
   for(i=1; <=12) {
      ThisAngle=(30 * (i-1));
      moveout=.09;
      moveout=12-myNumPlayers;
      moveout=.2-(moveout  * 0.012);
      MyAtX=GetXPointOnCircle(ThisAngle, moveout, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, moveout, .5);
      ThisAngle=(30 * (i));
      MyInfX=GetXPointOnCircle(ThisAngle, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle, moveout, .5);
      id = CreateAreaAtXZ("InnerRoad"+i, MyAtX, MyAtZ, rmXMetersToFraction(.5 + 0.1 * myNumPlayers), 2.0, 1);
      rmSetAreaTerrainType(id,GetRoadType());
      rmAddAreaInfluenceSegment(id, MyAtX, MyAtZ, MyInfX, MyInfZ);
      rmBuildArea(id);
   }

   string MarkerTypeN="Thor Hammer";
   if (rmRandInt(1,1)==1) MarkerTypeN="Statue of Major God";
   string MarkerTypeE="Statue Pharaoh";
   string MarkerTypeG="Poseidon Statue";
   int ArmoryId=rmCreateObjectDef("Armory");
   rmAddObjectDefItem(ArmoryId, "Armory", 1, 0.0);
   int FoundryId=rmCreateObjectDef("Foundry");
   rmAddObjectDefItem(FoundryId, "Dwarf Foundry", 1, 0.0);
   int TowerId=rmCreateObjectDef("Tower");
   rmAddObjectDefItem(TowerId, "Tower", 1, 0.0);
   int GoldId=rmCreateObjectDef("Gold Mine");
   rmAddObjectDefItem(GoldId, "Gold Mine Dwarven", 1, 0.0);
   rmSetObjectDefMinDistance(GoldId,0);
   rmSetObjectDefMaxDistance(GoldId,0);
   int FoodId=rmCreateObjectDef("PrisonFood");
   string Food=GetAnimalType(rmRandInt(1,3));
   rmAddObjectDefItem(FoodId,Food,1, 0.0);
   rmSetObjectDefMinDistance(FoodId,0);
   rmSetObjectDefMaxDistance(FoodId,0);

   int TowerAngle = iifF(myNumPlayers>7,6,9);
   // PLAYER OBJECTS
   for(i=1; <cNumberPlayers) {
      ThisSlot=getSlot(i);
      rmSetStatusText("",pct);
      pct = pct-0.09;

      ThisAngle=(PlayerAngle * (ThisSlot-1));
      MyAtX=GetXPointOnCircle(ThisAngle, PlayerDist, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, PlayerDist, .5);
      MyInfX=GetXPointOnCircle(ThisAngle-5, PlayerDist, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-5, PlayerDist, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle+5, PlayerDist, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle+5, PlayerDist, .5);
      if (rmGetPlayerCiv(i) == cCivThor) rmPlaceObjectDefAtLoc(FoundryId, i, MyAtX, MyAtZ, 1);
      else rmPlaceObjectDefAtLoc(ArmoryId, i, MyAtX, MyAtZ, 1);
      rmPlaceObjectDefAtLoc(GoldId, 0, MyInfX, MyInfZ, 1);
      rmPlaceObjectDefAtLoc(GoldId, 0, MyInf2X, MyInf2Z, 1);
      int stepangle=(360/GetAnimalCount(Food));
      ObjectsInACircle(FoodId, stepangle, 360, stepangle, rmZMetersToFraction(10), MyInfX, MyInfZ, 0, 1);
      ObjectsInACircle(FoodId, stepangle, 360, stepangle, rmZMetersToFraction(10), MyInf2X, MyInf2Z, 0, 1);

      MyAtX=GetXPointOnCircle(ThisAngle, .456, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, .456, .5);
      addStartingUnit("Ox Cart", i, MyInfX, MyInfZ, MyAtX, MyAtZ);
      addStartingUnit("Dwarf", i, MyInfX, MyInfZ, MyAtX, MyAtZ);
      addStartingUnit("Villager Norse", i, MyInf2X, MyInf2Z, MyAtX, MyAtZ);
      addStartingUnit("Villager Greek", i, MyInf2X, MyInf2Z, MyAtX, MyAtZ);
      //addStartingUnit("Villager Egyptian", i, MyInf2X, MyInf2Z, MyAtX, MyAtZ);

      moveout=.41;
      MyInfX=GetXPointOnCircle(ThisAngle-3, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-3, moveout, .5);
      moveout=.387;
      MyInf2X=GetXPointOnCircle(ThisAngle, moveout, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle, moveout, .5);
      addStartingUnit(CivPicker, i, MyInfX, MyInfZ, MyInf2X, MyInf2Z);
      if (cMapSize==1) { // LARGE MAPS GET TWO PICKERS
         moveout=.41;
         MyInfX=GetXPointOnCircle(ThisAngle+3, moveout, .5);
         MyInfZ=GetZPointOnCircle(ThisAngle+3, moveout, .5);
         moveout=.387;
         MyInf2X=GetXPointOnCircle(ThisAngle-3, moveout, .5);
         MyInf2Z=GetZPointOnCircle(ThisAngle-3, moveout, .5);
         addStartingUnit(CivPicker, i, MyInfX, MyInfZ, MyInf2X, MyInf2Z,1);
      }

      id=rmCreateObjectDef("cameraStart"+i);
      rmAddObjectDefItem(id, "Camera Start", 1, 0.0);
      rmSetObjectDefMinDistance(id, 0.0);
      rmSetObjectDefMaxDistance(id, 0.0);
      rmPlaceObjectDefAtLoc(id, i, MyInf2X, MyInf2Z);

      // CIV HOT SPOT OBJECTS
      moveout=.384;
      MyInfX=GetXPointOnCircle(ThisAngle-4, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-4, moveout, .5);
      id=rmCreateObjectDef("Marker1_p"+i);
      rmAddObjectDefItem(id, MarkerTypeN, 1, 0);
      rmSetObjectDefMinDistance(id,0);
      rmSetObjectDefMaxDistance(id,0);
      rmPlaceObjectDefAtLoc(id, i, MyInfX, MyInfZ, 1);
      id=rmGetUnitPlaced(id,0);
      setHotSpot_N(i, ""+id);

      MyInfX=GetXPointOnCircle(ThisAngle, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle, moveout, .5);
      id=rmCreateObjectDef("Marker2_p"+i);
      rmAddObjectDefItem(id, MarkerTypeE, 1, 0);
      rmSetObjectDefMinDistance(id,0);
      rmSetObjectDefMaxDistance(id,0);
      rmPlaceObjectDefAtLoc(id, i, MyInfX, MyInfZ, 1);
      id=rmGetUnitPlaced(id,0);
      setHotSpot_E(i, ""+id);

      MyInfX=GetXPointOnCircle(ThisAngle+4, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle+4, moveout, .5);
      id=rmCreateObjectDef("Marker3_p"+i);
      rmAddObjectDefItem(id, MarkerTypeG, 1, 0);
      rmSetObjectDefMinDistance(id,0);
      rmSetObjectDefMaxDistance(id,0);
      rmPlaceObjectDefAtLoc(id, i, MyInfX, MyInfZ, 1);
      id=rmGetUnitPlaced(id,0);
      setHotSpot_G(i, ""+id);

      // BUY PICKER
      moveout=.395;
      MyInf2X=GetXPointOnCircle(ThisAngle-2, moveout, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle-2, moveout, .5);
      id=rmCreateObjectDef("BuyPicker_p"+i);
      rmAddObjectDefItem(id, BuyPicker, 1, 0);
      rmSetObjectDefMinDistance(id,0);
      rmSetObjectDefMaxDistance(id,0);
      rmPlaceObjectDefAtLoc(id, i, MyInf2X, MyInf2Z, 1);
      id=rmGetUnitPlaced(id,0);
      setBuyPicker(i, ""+id);

      // KILL ZONE OBJECTS
      MyAtX=GetXPointOnCircle(ThisAngle, KillLoc+.045, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, KillLoc+.045, .5);
      id=rmCreateObjectDef("home"+i);
      rmAddObjectDefItem(id, PlayerBase, 1, 0.0);
      rmSetObjectDefMinDistance(id, 0.0);
      rmSetObjectDefMaxDistance(id, 0.0);
      rmPlaceObjectDefAtLoc(id, i, MyAtX, MyAtZ, 1);

      MyInfX=GetXPointOnCircle(ThisAngle-TowerAngle, KillLoc+.00, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-TowerAngle, KillLoc+.00, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle+TowerAngle, KillLoc+.00, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle+TowerAngle, KillLoc+.00, .5);
      rmPlaceObjectDefAtLoc(TowerId, i, MyInfX, MyInfZ, 1);
      rmPlaceObjectDefAtLoc(TowerId, i, MyInf2X, MyInf2Z, 1);
      MyInf2X=GetXPointOnCircle(ThisAngle, KillLoc+.08, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle, KillLoc+.08, .5);
      rmPlaceObjectDefAtLoc(TowerId, i, MyInf2X, MyInf2Z, 1);

      rmEchoInfo("Placed Objects for player "+i);
   }

   AddPlentyVault(0, .5, .5);
   int NumVaults = myNumPlayers-2+(2 * cMapSize);
   int VaultAngle = 360/NumVaults; // LARGE MAPS GET MORE VAULTS
   for(i=1; <=NumVaults) {
      ThisAngle=(VaultAngle * (i-1));
      MyInfX=GetXPointOnCircle(ThisAngle+VaultAngle/4, KillLoc-(0.045+(.008 * myNumPlayers/2)), .5);
      MyInfZ=GetZPointOnCircle(ThisAngle+VaultAngle/4, KillLoc-(0.045+(.008 * myNumPlayers/2)), .5);
      AddPlentyVault(i,MyInfX, MyInfZ);
      //if (i%2==0 || cMapSize==1)
   }

   rmSetStatusText("",pct);
   pct = pct-0.05;
   int init=0;
   //********************************************************************
   // ************* TRIGGERS ****
   //********************************************************************

   PlayerLost(); // TRIGGER THAT DETERMINES WHEN PLAYER HAS LOST GAME
   //BuildTax();  // TRIGGER TO KEEP PLAYERS FROM REPAIRING CITADELS

   for(i=1; <cNumberPlayers) {
      rmSetStatusText("",pct);
      pct = pct-0.09;
      init=3; // START PLAYER INIT AFTER 3 SECONDS SO GAME STARTS UP FAST, THEN LAGS
      id = rmCreateTrigger("init_player"+i+"_"+init);
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", init, false);
//      rmSetTriggerRunImmediately(true);
      SetTechStatus(i, cTechPlentyKOTHenable, cTechStatusActive); // Enable resouces for Plenty Vault
      SetTechStatus(i, cTechWatchTower, cTechStatusActive); // LET TOWERS FIRE
      SetTechStatus(i, cTechSignalFires, cTechStatusActive); // Buildings have +6 LOS
      // VILLAGERS ARE WICKED
      for(j=1; <=9) SetTechStatus(i, cTechRelicSistrumofBast, cTechStatusActive);//Villagers cost 10% less
      for(j=1; <=3) SetTechStatus(i, cTechRelicPygmalionsStatue, cTechStatusActive);//Villagers have 40% more HP
      for(j=1; <=2) SetTechStatus(i, cTechSkinOfTheRhino, cTechStatusActive);//Villagers -30% hack/pierce vuln, +10% attack

      init=init+1;
      id = rmCreateTrigger("init_player"+i+"_"+init);
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", init, false);
      // BUILDING BEEFUPS
      for(j=1; <=4) SetTechStatus(i, cTechRelicArrowsofAlfar, cTechStatusActive);//Towers, Fortresses and Town Centers have 20% more attack
      for(j=1; <=4) SetTechStatus(i, cTechCarrierPigeons, cTechStatusActive); // Buildings have +6 LOS
      // AGE EM UP
//      SetTechStatus(i, cTechAge2Heimdall, cTechStatusActive);
//      SetTechStatus(i, cTechAge3Njord, cTechStatusActive);
//      SetTechStatus(i, cTechAge4Baldr, cTechStatusActive);
//      rmAddTriggerEffect("Player Kill All God Powers");
//      rmSetTriggerEffectParamInt("Player", i, false);

      init=init+1;
      id = rmCreateTrigger("init_player"+i+"_"+init);
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Timer");
       rmSetTriggerConditionParamInt("Param1", init, false);
      for(j=0; <=12) SetTechStatus(i, cTechRelicNoseoftheSphinx, cTechStatusActive); // Buildings have 15% more HP

      // UPGRADE HUMAN SOLIDERS
      init=init+1;
      id = rmCreateTrigger("init_player"+i+"_"+init);
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", init, false);
      SetTechStatus(i, cTechMediumArchers, cTechStatusActive);
      SetTechStatus(i, cTechMediumAxemen, cTechStatusActive);
      SetTechStatus(i, cTechMediumCavalry, cTechStatusActive);
      SetTechStatus(i, cTechMediumInfantry, cTechStatusActive);
      SetTechStatus(i, cTechMediumSlingers, cTechStatusActive);
      SetTechStatus(i, cTechMediumSpearmen, cTechStatusActive);
      SetTechStatus(i, cTechHeavyArchers, cTechStatusActive);
      SetTechStatus(i, cTechHeavyAxemen, cTechStatusActive);
      SetTechStatus(i, cTechHeavyCamelry, cTechStatusActive);
      SetTechStatus(i, cTechHeavyCavalry, cTechStatusActive);
      SetTechStatus(i, cTechHeavyChariots, cTechStatusActive);
      SetTechStatus(i, cTechHeavyElephants, cTechStatusActive);
      SetTechStatus(i, cTechHeavyInfantry, cTechStatusActive);
      SetTechStatus(i, cTechHeavySlingers, cTechStatusActive);
      SetTechStatus(i, cTechHeavySpearmen, cTechStatusActive);
      SetTechStatus(i, cTechChampionArchers, cTechStatusActive);
      SetTechStatus(i, cTechChampionAxemen, cTechStatusActive);
      SetTechStatus(i, cTechChampionCamelry, cTechStatusActive);
      SetTechStatus(i, cTechChampionCavalry, cTechStatusActive);
      SetTechStatus(i, cTechChampionChariots, cTechStatusActive);
      SetTechStatus(i, cTechChampionElephants, cTechStatusActive);
      SetTechStatus(i, cTechChampionInfantry, cTechStatusActive);
      SetTechStatus(i, cTechChampionSlingers, cTechStatusActive);
      SetTechStatus(i, cTechChampionSpearmen, cTechStatusActive);

      init=init+1;
      id = rmCreateTrigger("init_player"+i+"_"+init);
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", init, false);
      //NORSE
      SetTechStatus(i, cTechLoneWanderer, cTechStatusActive); // Ulfsark speed +10%
      SetTechStatus(i, cTechWinterHarvest, cTechStatusActive); // Villagers gather food from farms 20% faster.
      SetTechStatus(i, cTechEyesintheForest, cTechStatusActive); //Infantry LOS +3
      SetTechStatus(i, cTechHamarrtroll, cTechStatusActive); // Troll hitpoints +50 LOS +2 pierce +20%
      SetTechStatus(i, cTechHallofThanes, cTechStatusActive); //275;
      SetTechStatus(i, cTechMithrilBreastplate, cTechStatusActive); // Ulfsark hack armor +10%
      SetTechStatus(i, cTechEldhrimnirKettle, cTechStatusActive); // Einheriar hack +6 hitpoints +10%
      SetTechStatus(i, cTechAuroraBorealis, cTechStatusActive); // Valkyrie hack +50% crush +20% heal rate +33% Reginleif ranged attack +50%  heal rate +50%
      SetTechStatus(i, cTechThunderingHooves, cTechStatusActive); // Cavalry speed increased 10% hitpoints +20% Valkyrie speed +20% hitpoints increased 10%

      SetTechStatus(i, cTechRime, cTechStatusActive); // Frost Giant hitpoints +33% hack attack +20% special attack recharge time decreased by 25%
      SetTechStatus(i, cTechHuntressAxe, cTechStatusActive); // Throwing Axemen hack attack +20%
      SetTechStatus(i, cTechCallOfValhalla, cTechStatusActive); // Increases ulfsark hitpoints by 20%
      SetTechStatus(i, cTechThurisazRune, cTechStatusActive); // Myth unit speed +12%
      SetTechStatus(i, cTechSwineArray, cTechStatusActive);  // Raiders gain 100% hack attack bonus vs. ulfsarks
      SetTechStatus(i, cTechRingGiver, cTechStatusActive); // Jarl hitpoints increased 25%
      SetTechStatus(i, cTechGraniteBlood, cTechStatusActive); // Mountain, Frost and Fire Giant hitpoints +100
      SetTechStatus(i, cTechBerserkergang, cTechStatusActive); //Ulfsark hitpoints increased 20% Ulfsark hack attack increased 10%
      SetTechStatus(i, cTechBravery, cTechStatusActive); //40; // Increases huskarl hack attack by 20% Doubles huskarl damage vs. buildings
      SetTechStatus(i, cTechSonsofSleipnir, cTechStatusActive); // Raiding cavalry get a 2x damage multiplier vs. archers and throwing axemen
      SetTechStatus(i, cTechDwarvenAuger, cTechStatusActive);  // Portable rams move 20% faster, train 50% faster, crush attack +20%

      init=init+1;
      id = rmCreateTrigger("init_player"+i+"_"+init);
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", init, false);
      //EGYPT
      SetTechStatus(i, cTechFeral, cTechStatusActive); // Set Animals Hack+50%, Pierce+10%, HA+10%, HP+10%
      SetTechStatus(i, cTechFeral, cTechStatusActive); // Set Animals Hack+50%, Pierce+10%, HA+10%, HP+10%
      SetTechStatus(i, cTechFeral, cTechStatusActive); // Set Animals Hack+50%, Pierce+10%, HA+10%, HP+10%
      SetTechStatus(i, cTechFeral, cTechStatusActive); // Set Animals Hack+50%, Pierce+10%, HA+10%, HP+10%
      SetTechStatus(i, cTechFeral, cTechStatusActive); // Set Animals Hack+50%, Pierce+10%, HA+10%, HP+10%
      SetTechStatus(i, cTechFeral, cTechStatusActive); // Set Animals Hack+50%, Pierce+10%, HA+10%, HP+10%
      SetTechStatus(i, cTechFeetoftheJackal, cTechStatusActive); // Anubite HP +50 Maximum jump range set to 6 hack +20%
      SetTechStatus(i, cTechSerpentSpear, cTechStatusActive); //spearman hack+10%
      SetTechStatus(i, cTechScallopedAxe, cTechStatusActive); // Axeman hack+10%
      SetTechStatus(i, cTechLeatherFrameShield, cTechStatusActive); // spearman PA+10%
      SetTechStatus(i, cTechElectrumBullets, cTechStatusActive); // Slinger Pierce+10%
      SetTechStatus(i, cTechBoneBow, cTechStatusActive); // Chariot Archer range +4
      SetTechStatus(i, cTechSlingsoftheSun, cTechStatusActive); // Slingers get a 30% damage bonus vs. infantry and throwing axemen
      SetTechStatus(i, cTechCriosphinx, cTechStatusActive); // Sphinx HP +50% hack +20% crush +50%
      SetTechStatus(i, cTechHieracosphinx, cTechStatusActive); //Sphinx speed +20% hack  +20% crush  +50%
      SetTechStatus(i, cTechCrocodopolis, cTechStatusActive); //Petsuchos range +4 Petsuchos LOS +4
      SetTechStatus(i, cTechMedjay, cTechStatusActive); // Mercenary and mercenary cavalry last 30 seconds longer
      SetTechStatus(i, cTechFuneralRites, cTechStatusActive); // Priests and pharaohs get a 4x damage multiplier vs. myth units
      SetTechStatus(i, cTechSpiritofMaat, cTechStatusActive); // Priests and Pharaoh double heal rate,
      SetTechStatus(i, cTechCityoftheDead, cTechStatusActive); // Pharaoh pierce damage +20%  hitpoints +30
      SetTechStatus(i, cTechAtefCrown, cTechStatusActive); // Mummy pierce attack +40% Lifespan of minions doubled Mummy hitpoints +20%
      SetTechStatus(i, cTechDesertWind, cTechStatusActive); // Camel speed +20% hack attack +20% hitpoints +20%
      SetTechStatus(i, cTechTusksofApedemak, cTechStatusActive); // War elephant hitpoints +20% hack attack +10%
      SetTechStatus(i, cTechAxeofVengeance, cTechStatusActive); // Axemen gain a damage multiplier of 2 vs. buildings.
      SetTechStatus(i, cTechGreatestofFifty, cTechStatusActive); //Spearmen hack armor increased 15% gain 100% bonus vs. cavalry
      SetTechStatus(i, cTechSpearontheHorizon, cTechStatusActive); //Spearmen hitpoints +30% hack attack +10%

      init=init+1;
      id = rmCreateTrigger("init_player"+i+"_"+init);
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", init, false);
      //GREEKS
      SetTechStatus(i, cTechLabyrinthofMinos, cTechStatusActive); // Minotaur costs 25% less food hitpoints +40%
      SetTechStatus(i, cTechAegisShield, cTechStatusActive); // Hoplite pierce armor +10%
      SetTechStatus(i, cTechSarissa, cTechStatusActive); // Hoplite hack armor +10%
      SetTechStatus(i, cTechSylvanLore, cTechStatusActive); // Centaur hitpoints +25% speed +30%
      SetTechStatus(i, cTechSpiritedCharge, cTechStatusActive); //Cavalry speed increased 10% hack damage increased 10%
      SetTechStatus(i, cTechPhobosSpearofPanic, cTechStatusActive); // Hoplite hack attack +10%
      SetTechStatus(i, cTechDeimosSwordofDread, cTechStatusActive); // Hypaspist hack attack +15%
      SetTechStatus(i, cTechEnyosBowofHorror, cTechStatusActive); // Toxotes pierce attack +10%
      SetTechStatus(i, cTechBacchanalia, cTechStatusActive); // All units hitpoints are +5%
      SetTechStatus(i, cTechThracianHorses, cTechStatusActive); // Cavalry hitpoints +20%
      SetTechStatus(i, cTechRoarofOrthus, cTechStatusActive); // Nemean Lion pierce armor +50% hack armor +20%
      SetTechStatus(i, cTechFaceoftheGorgon, cTechStatusActive); //Increases medusa hitpoints by 33%
      SetTechStatus(i, cTechMonstrousRage, cTechStatusActive); // Myth Pierce, Hack, Crush + 25%
      SetTechStatus(i, cTechShaftsofPlague, cTechStatusActive); // Archer pierce attack +15%
      SetTechStatus(i, cTechFlamesofTyphon, cTechStatusActive); // Chimera hack attack +30% HP +20% special attack +30%
      SetTechStatus(i, cTechHandofTalos, cTechStatusActive);//Colossus hitpoints +100
      SetTechStatus(i, cTechShoulderofTalos, cTechStatusActive);//Increases colossus hitpoints by 200  hack armor by 20%
      SetTechStatus(i, cTechWeaponoftheTitans, cTechStatusActive); // Gastrophetes pierce +20% crush +20% Myrmidon hack +20% Hetairoi hack +20%

      init=init+1;
      id = rmCreateTrigger("init_player"+i+"_"+init);
      rmSwitchToTrigger(id);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", init, false);
      for(j=0; <=60) SetTechStatus(i, cTechRelicEyeofHorus, cTechStatusActive); // settlements support +2 population

   }
   // MULTIPLY RESEARCHED TECH X 3
   //TC
   addTechAvailMuliplier(cTechMasons,"Masons and now has stronger buildings",2);
   addTechAvailMuliplier(cTechArchitects,"Architects and now has stronger buildings");
   addTechAvailMuliplier(cTechFortifyTownCenter,"Fortified Town Center and get free Sentinels",2);
   //addTechAvailMuliplier(cTechStoneWall,"Stone Walls.",2); // WALL TOO STRONG
   //OX
   addTechAvailMuliplier(cTechHusbandry);
   addTechAvailMuliplier(cTechHuntingDogs);
   addTechAvailMuliplier(cTechHandAxe,"Hand Axe and gets a bonus Laborer",3);
   addTechAvailMuliplier(cTechPickaxe,"Pick Axe and gets a bonus Laborer",3);
   addTechAvailMuliplier(cTechPlow,"Plow and gets a bonus Laborer",3);
   addTechAvailMuliplier(cTechBowSaw);
   addTechAvailMuliplier(cTechShaftMine);
   addTechAvailMuliplier(cTechIrrigation);
   addTechAvailMuliplier(cTechCarpenters);
   addTechAvailMuliplier(cTechQuarry);
   addTechAvailMuliplier(cTechFloodControl);
   addTechAvailMuliplier(cTechPigSticker);

   // TOWERS
   addTechAvailMuliplier(cTechCrenellations,"Crenellations",2,1);
   addTechAvailMuliplier(cTechBoilingOil,"Boiling Oil",2,1);
   addTechAvailMuliplier(cTechSafeguard,"Safeguard. Their towers are now deadlier",2,1);
   // ARMORY
   addTechAvailMuliplier(cTechBronzeMail,"Bronze Mail",1);
   addTechAvailMuliplier(cTechBronzeShields,"Bronze Shields",1);
   addTechAvailMuliplier(cTechBronzeWeapons,"Bronze Weapons",1);
   addTechAvailMuliplier(cTechCopperMail,"Copper Mail",1);
   addTechAvailMuliplier(cTechCopperShields,"Copper Shields",1);
   addTechAvailMuliplier(cTechCopperWeapons,"Copper Weapons",1);
   addTechAvailMuliplier(cTechIronMail,"Iron Mail and has fully upgraded Mail",1);
   addTechAvailMuliplier(cTechIronShields,"Iron Shields and has fully upgraded Shields",1);
   addTechAvailMuliplier(cTechIronWeapons,"Iron Weapons and has fully upgraded Weapons",1);
   addTechAvailMuliplier(cTechBurningPitch,"Buring Pitch",1);

   string NorseSpawn="N*Ulf-0/T.Axe-15/R.Cav-30/Husky-45/Jarl-60/Ballista-75/P.Ram-95";
   string EgyptSpawn="E*Sling-0/Axe-15/Camel-30/Spear-45/C.Arch-60/WarEl-75/Catplt-95";
   string GreekSpawn="G*Hoplite-0/Tox-15/Prodr-30/Gastr-45/Myrm-60/Hipp-75/Helep-95";

   string sUnitN="Ulfsark"; // Infantry
   string sUnitE="Slinger"; // Archer
   string sUnitG="Hoplite"; // Infantry
   //addSpawningUnit(name, count, time, favor, cult, maxCount)
   addSpawningUnit("n1",sUnitN, 1, 2, 0, cCultureNorse);
   addSpawningUnit("e1",sUnitE, 1, 2, 0, cCultureEgyptian);
   addSpawningUnit("g1",sUnitG, 1, 2, 0, cCultureGreek);

   sUnitN="Throwing Axeman"; // Infantry
   sUnitE="Axeman"; // Infantry
   sUnitG="Toxotes"; // Archer
   addSpawningUnit("n2",sUnitN, 1, 3, 15, cCultureNorse);
   addSpawningUnit("e2",sUnitE, 1, 3, 15, cCultureEgyptian);
   addSpawningUnit("g2",sUnitG, 1, 3, 15, cCultureGreek);

   sUnitN="Raiding Cavalry"; // Cavalry
   sUnitE="Camelry"; // Cavalry
   sUnitG="Prodromos"; // Cavalry
   addSpawningUnit("n3",sUnitN, 1, 5, 30, cCultureNorse);
   addSpawningUnit("e3",sUnitE, 1, 5, 30, cCultureEgyptian);
   addSpawningUnit("g3",sUnitG, 1, 5, 30, cCultureGreek);

   sUnitN="Huskarl"; // Infantry
   sUnitE="Spearman"; // Infantry
   sUnitG="Gastraphetes"; // Archer
   addSpawningUnit("n4",sUnitN, 1, 7, 45, cCultureNorse);
   addSpawningUnit("e4",sUnitE, 1, 7, 45, cCultureEgyptian);
   addSpawningUnit("g4",sUnitG, 1, 7, 45, cCultureGreek);

   sUnitN="Jarl"; // Cavalry
   sUnitE="Chariot Archer"; // Archer
   sUnitG="Myrmidon"; // Infantry
   addSpawningUnit("n5",sUnitN, 1, 9, 60, cCultureNorse);
   addSpawningUnit("e5",sUnitE, 1, 9, 60, cCultureEgyptian);
   addSpawningUnit("g5",sUnitG, 1, 9, 60, cCultureGreek);

   sUnitN="Ballista"; // Archer/Seige
   sUnitE="War Elephant"; // Cavalry
   sUnitG="Hippikon"; // Cavalry
   addSpawningUnit("n6",sUnitN, 1,11, 75, cCultureNorse);
   addSpawningUnit("e6",sUnitE, 1,11, 75, cCultureEgyptian);
   addSpawningUnit("g6",sUnitG, 1,11, 75, cCultureGreek);

   sUnitN="Portable Ram"; // Seige
   sUnitE="Catapult"; // Seige
   sUnitG="Helepolis"; // Seige
   addSpawningUnit("n7",sUnitN, 1, 13, 95, cCultureNorse,5);
   addSpawningUnit("e7",sUnitE, 1, 13, 95, cCultureEgyptian,5);
   addSpawningUnit("g7",sUnitG, 1, 13, 95, cCultureGreek,5);

   BuyMythList=PickNorseMyth(1,MythUnit_N); // ADDS BUY UNIT TRIGGERS ON THIS CALL
   BuyMythList=BuyMythList+PickEgyptMyth(1,MythUnit_E);
   BuyMythList=BuyMythList +PickGreekMyth(1,MythUnit_G);

   if (whichhero1==1) BuyHeroList=PickNorseHero(1,HeroUnit1);
   else if (whichhero1==2) BuyHeroList=PickEgyptHero(1,HeroUnit1);
   else BuyHeroList=PickGreekHero(1,HeroUnit1);

   if (whichhero2==1) BuyHeroList=BuyHeroList+PickNorseHero(1,HeroUnit2);
   else if (whichhero2==2) BuyHeroList=BuyHeroList+PickEgyptHero(1,HeroUnit2);
   else BuyHeroList=BuyHeroList+PickGreekHero(1,HeroUnit2);

   BuyGPList=PickNorseGodPower();
   BuyGPList=BuyGPList + " " + PickEgyptGodPower();
   BuyGPList=BuyGPList + " " + PickGreekGodPower();

   k = rmRandInt(1,11); // PLACE ONE FOR EACH PLAYER
   string RelicDesc = "";
   for(i=1; <cNumberPlayers * rmRandFloat(1,2)) {
      if (k==1) {PlaceRelic(i,cTechRelicTriosBow); RelicDesc = "Trios Bow: Archer and Ballista range +2";}
      if (k==2) {PlaceRelic(i,cTechRelicTailofCerberus); RelicDesc = "Tail of Cerberus: Myth special attack recharge time reduced 25%%";}
      if (k==3) {PlaceRelic(i,cTechRelicOdinsSpear); RelicDesc = "Odins Spear: Hoplites, Spearmen and Ulfsarks +5%% hack attack";}
      if (k==4) {PlaceRelic(i,cTechRelicEyeofOrnlu); RelicDesc = "Eye of Ornlu: Throwing Axemen, Hypaspists and Axemen +5%% attack";}
      if (k==5) {PlaceRelic(i,cTechRelicToothedArrows); RelicDesc = "Toothed Arrows: Archer and Ballista +5%% pierce damage";}
      if (k==6) {PlaceRelic(i,cTechRelicTowerofSestus); RelicDesc = "Tower of Sestus: Tower ranged attack +30%%, burning oil attack +10%%";}
      if (k==7) {PlaceRelic(i,cTechRelicBootsofKickEverything); RelicDesc = "Boots of Kick Everything-Heroes are 20%% faster";}
      if (k==8) {PlaceRelic(i,cTechRelicMithrilHorseshoes); RelicDesc = "Mithril Horseshoes-Cavalry move 10%% faster";}
      if (k==9) {PlaceRelic(i,cTechRelicArmorofAchilles); RelicDesc = "Armor of Achilles-Adds 5%% to infantry hack armor";}
      if (k==10) {PlaceRelic(i,cTechRelicHerasThundercloudShawl); RelicDesc = "Hera's Thundercloud Shawl-Human unit pierce armor increased by 5%%";}
      if (k==11) {PlaceRelic(i,cTechRelicTuskoftheIronBoar); RelicDesc = "Tusk of the Iron Boar-Cavalry and Chariot Archers have 10%% more hit points";}
   }
   if (rmRandInt(1,10)==1) PlaceRelic(33,cTechRelicRingoftheNibelung); //Ring of the Nibelung-Provides a small continuous income of gold
   if (rmRandInt(1,10)==1) PlaceRelic(34,cTechRelicShipofFingernails); //Ship of Fingernails-Provides a small continuous trickle of food
   if (rmRandInt(1,10)==1) PlaceRelic(35,cTechRelicAnvilofHephaestus); //Anvil of Hephaestus-Reduces cost of armory upgrades by 10%
   if (rmRandInt(1,15)==1) PlaceRelic(36,cTechRelicAnkhofRa); //Ankh of Ra-Provides a steady trickle of favor

   id = rmCreateTrigger("display_instructions1");
   id = rmCreateTrigger("display_instructions2");
   id = rmCreateTrigger("display_instructions3");
   id = rmCreateTrigger("display_instructions4");
   id = rmCreateTrigger("display_instructions5");
   id = rmCreateTrigger("display_instructions6");

   k=1;
   rmSwitchToTrigger(rmTriggerID("display_instructions"+k));
   k=k+1;
   rmSetTriggerLoop(false);
   rmSetTriggerPriority(3);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 1, false);
   rmAddTriggerEffect("Message");
   rmSetTriggerEffectParamInt("Timeout", 3000, false);
   rmSetTriggerEffectParam("Text", "**** SpillBlood Version 1.3 by TwentyOneScore@BeerInHand.com ****", false);
   if(MapSkin==1){
      rmAddTriggerEffect("Render Snow");
      rmSetTriggerEffectParamFloat("Percent",0.90);
   }
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParam("EventID", ""+rmTriggerID("display_instructions"+k), false);

   rmSwitchToTrigger(rmTriggerID("display_instructions"+k));
   k=k+1;
   rmSetTriggerActive(false);
   rmSetTriggerPriority(3);
   rmSetTriggerLoop(false);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 3, false);
   rmAddTriggerEffect("Message");
   rmSetTriggerEffectParamInt("Timeout", 20000, false);
   rmSetTriggerEffectParam("Text", "Move SWORD to CIV STATUE picks SPAWNING CIV. Move.HAFT.to.CIV.STATUE.buys.CIVs.GOD.POWER Move.HAFT.to.MYTH/HERO.buys.MYTH/HERO", false);
   if(MapSkin==1){
      rmAddTriggerEffect("Render Snow");
      rmSetTriggerEffectParamFloat("Percent",0.60);
   }
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParam("EventID", ""+rmTriggerID("display_instructions"+k), false);

   rmSwitchToTrigger(rmTriggerID("display_instructions"+k));
   k=k+1;
   rmSetTriggerActive(false);
   rmSetTriggerPriority(3);
   rmSetTriggerLoop(false);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 12, false);
   if(MapSkin==1){
      rmAddTriggerEffect("Render Snow");
      rmSetTriggerEffectParamFloat("Percent",0.30);
   }
   SendChat(NorseSpawn);
   SendChat(EgyptSpawn);
   SendChat(GreekSpawn);
   SendChat(BuyGPList);
   SendChat("*Hero* " + BuyHeroList);
   SendChat("*Myth* " + BuyMythList);
   SendChat("Free Units Spawn based on Favor. Move Sword Bearer to Statue to Pick Civ");
   SendChat("Buy God Powers with Favor at Civ Statue with Haft Bearer.");
   SendChat("Buy Myth & Heroes with Favor and Resources using Haft Bearer to select.");
   SendChat("Buy Upgrades at Armory & Town Center. Upgrades give 3X normal bonus.");
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParam("EventID", ""+rmTriggerID("display_instructions"+k), false);

   rmSwitchToTrigger(rmTriggerID("display_instructions"+k));
   k=k+1;
   rmSetTriggerActive(false);
   rmSetTriggerPriority(3);
   rmSetTriggerLoop(false);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 30, false);
   if(MapSkin==1){
      rmAddTriggerEffect("Render Snow");
      rmSetTriggerEffectParamFloat("Percent",0.20);
   }
   TimedMsg(BuyGPList);
   TimedMsg("*Hero* " + BuyHeroList);
   TimedMsg("*Myth* " + BuyMythList);
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParam("EventID", ""+rmTriggerID("display_instructions"+k), false);

   rmSwitchToTrigger(rmTriggerID("display_instructions"+k));
   k=k+1;
   rmSetTriggerPriority(3);
   rmSetTriggerLoop(false);
   rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 30, false);
   if(MapSkin==1){
      rmAddTriggerEffect("Render Snow");
      rmSetTriggerEffectParamFloat("Percent",0.40);
   }
   TimedMsg(NorseSpawn);
   TimedMsg(EgyptSpawn);
   TimedMsg(GreekSpawn);
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParam("EventID", ""+rmTriggerID("display_instructions"+k), false);

   rmSwitchToTrigger(rmTriggerID("display_instructions"+k));
   k=k+1;
   rmSetTriggerPriority(3);
   rmSetTriggerLoop(false);
   rmSetTriggerActive(false);
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1", 60, false);
   if(MapSkin==1){
      rmAddTriggerEffect("Render Snow");
      rmSetTriggerEffectParamFloat("Percent",0.20);
   }
   SendChat(NorseSpawn);
   SendChat(EgyptSpawn);
   SendChat(GreekSpawn);
   SendChat(BuyGPList);
   SendChat("*Hero* " + BuyHeroList);
   SendChat("*Myth* " + BuyMythList);
   rmAddTriggerEffect("Fire Event");
   rmSetTriggerEffectParam("EventID", ""+rmTriggerID("display_instructions4"), false);

   for(i=1; <cNumberPlayers) { // START OFF PLAYERS WITH RESOURCES
      rmSetPlayerResource(i, "favor", 15);
      rmSetPlayerResource(i, "food", 0);
      rmSetPlayerResource(i, "wood",0);
      rmSetPlayerResource(i, "gold",0);
   }
   // THIS AREA IS CREATED AT END DUE TO BUG - WHEN PLACING FORESTS DstObject DON"T FIRE RIGHT
   // SNEAKY ROAD
   for(i=1; <=12) {
      rmSetStatusText("",pct);
      pct = pct-0.09;
      ThisAngle=(30 * (i-1));
      moveout=12-myNumPlayers;
      moveout=.33-(moveout  * 0.012);
      MyAtX=GetXPointOnCircle(ThisAngle, moveout, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, moveout, .5);
      MyInfX=GetXPointOnCircle(ThisAngle-15, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-15, moveout, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle+15, moveout, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle+15, moveout, .5);
      id = CreateAreaAtXZ("WallOfTrees"+i, MyAtX, MyAtZ, rmXMetersToFraction(.8 + 0.1 * myNumPlayers), 2.0, 1);
      rmSetAreaForestType(id,GetTreeType(1));
      rmAddAreaInfluenceSegment(id, MyInf2X, MyInf2Z, MyInfX, MyInfZ);
      rmBuildArea(id);
      moveout=moveout-0.015;
      MyAtX=GetXPointOnCircle(ThisAngle, moveout, .5);
      MyAtZ=GetZPointOnCircle(ThisAngle, moveout, .5);
      MyInfX=GetXPointOnCircle(ThisAngle-15, moveout, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-15, moveout, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle+15, moveout, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle+15, moveout, .5);
      id = CreateAreaAtXZ("SneakRoad"+i, MyAtX, MyAtZ, rmXMetersToFraction(.8 + 0.3 * myNumPlayers), 2.0, 1);
      rmSetAreaTerrainType(id,GetRoadType());
      rmAddAreaInfluenceSegment(id, MyInf2X, MyInf2Z, MyInfX, MyInfZ);
      rmBuildArea(id);
   }

   for(i=1; <cNumberPlayers) {
      ThisAngle=(PlayerAngle * (i-1));
      MyInfX=GetXPointOnCircle(ThisAngle-13, KillLoc*1.075, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle-13, KillLoc*1.075, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle-(PlayerAngle/2), KillLoc*1.23, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle-(PlayerAngle/2), KillLoc*1.23, .5);
      id = CreateAreaAtXZ("Inner1WallOfTrees"+i, MyInfX, MyInfZ, rmXMetersToFraction(.2 + 0.05 * myNumPlayers), 2.0, 1);
      rmSetAreaForestType(id,GetTreeType(1));
      rmAddAreaInfluenceSegment(id, MyInfX, MyInfZ, MyInf2X, MyInf2Z);
      rmBuildArea(id);
      MyInfX=GetXPointOnCircle(ThisAngle+13, KillLoc*1.075, .5);
      MyInfZ=GetZPointOnCircle(ThisAngle+13, KillLoc*1.075, .5);
      MyInf2X=GetXPointOnCircle(ThisAngle+(PlayerAngle/2), KillLoc*1.23, .5);
      MyInf2Z=GetZPointOnCircle(ThisAngle+(PlayerAngle/2), KillLoc*1.23, .5);
      id = CreateAreaAtXZ("Inner2WallOfTrees"+i, MyInfX, MyInfZ, rmXMetersToFraction(.2 + 0.05 * myNumPlayers), 2.0, 1);
      rmSetAreaForestType(id,GetTreeType(1));
      rmAddAreaInfluenceSegment(id, MyInfX, MyInfZ, MyInf2X, MyInf2Z);
      rmBuildArea(id);
   }

   rmSetObjectDefMinDistance(GoldId,rmZFractionToMeters(KillLoc/3));
   rmSetObjectDefMaxDistance(GoldId,rmZFractionToMeters(KillLoc));
   rmAddObjectDefConstraint(GoldId, avoidBuildingsLong);
   rmAddObjectDefConstraint(GoldId, avoidGoldLong);
   for(i=1; <myNumPlayers/2) {
      rmPlaceObjectDefAtLoc(GoldId, 0, .5, .5, 1);
   }
}

// ** FUTURE IDEAS
